_cqa_text_report = {
  paths = {
    {
      hint = {
        {
          details = "These instructions generate more than one micro-operation and only one of them can be decoded during a cycle and the extra micro-operations increase pressure on execution units.\n - VCVTPD2PS: 2 occurrences\n - VCVTPS2PD: 4 occurrences\n",
          title = "Complex instructions",
          txt = "Detected COMPLEX INSTRUCTIONS.\n",
        },
        {
          workaround = " - Pass to your compiler a micro-architecture specialization option:\n  * Please read your compiler manual\n - Use vector aligned instructions:\n  1) align your arrays on 64 bytes boundaries: replace { void *p = malloc (size); } with { void *p; posix_memalign (&p, 64, size); }.\n  2) inform your compiler that your arrays are vector aligned: read your compiler manual.\n",
          details = " - VEXTRACTF32X4: 2 occurrences\n - VINSERTF128: 1 occurrences\n",
          title = "Vector unaligned load/store instructions",
          txt = "Detected 3 suboptimal vector unaligned load/store instructions.\n",
        },
        {
          workaround = "Avoid mixing data with different types. In particular, check if the type of constants is the same as array elements. Use double instead of single precision only when/where needed by numerical stability and avoid mixing precision. In C/C++, FP constants are double precision by default and must be suffixed by 'f' to make them single precision.",
          details = " - VCVTPD2PS (FP64 to FP32, SIMD): 2 occurrences\n - VCVTPS2PD (FP32 to FP64, SIMD): 4 occurrences\n",
          title = "Conversion instructions",
          txt = "Detected expensive conversion instructions.",
        },
        {
          title = "Type of elements and instruction set",
          txt = "18 AVX instructions are processing arithmetic or math operations on single precision FP elements in vector mode (eight at a time).\n8 AVX instructions are processing arithmetic or math operations on double precision FP elements in vector mode (four at a time).\n",
        },
        {
          title = "Matching between your loop (in the source code) and the binary loop",
          txt = "The binary loop is composed of 248 FP arithmetical operations:\n - 120: addition or subtraction (88 inside FMA instructions)\n - 112: multiply (88 inside FMA instructions)\n - 8: divide\n - 8: square root\nThe binary loop is loading 128 bytes (32 single precision FP elements).",
        },
        {
          title = "Arithmetic intensity",
          txt = "Arithmetic intensity is 1.94 FP operations per loaded or stored byte.",
        },
      },
      expert = {
        {
          title = "General properties",
          txt = "nb instructions    : 43\nnb uops            : 48\nloop length        : 251\nused x86 registers : 6\nused mmx registers : 0\nused xmm registers : 4\nused ymm registers : 28\nused zmm registers : 0\nnb stack references: 0\nADD-SUB / MUL ratio: 1.00\n",
        },
        {
          title = "Front-end",
          txt = "ASSUMED MACRO FUSION\nFIT IN UOP CACHE\nmicro-operation queue: 12.00 cycles\nfront end            : 12.00 cycles\n",
        },
        {
          title = "Back-end",
          txt = "       | P0    | P1    | P2   | P3   | P4   | P5    | P6   | P7\n-----------------------------------------------------------------\nuops   | 15.00 | 15.00 | 2.00 | 2.00 | 0.00 | 11.00 | 2.00 | 0.00\ncycles | 15.00 | 15.00 | 2.00 | 2.00 | 0.00 | 11.00 | 2.00 | 0.00\n\nCycles executing div or sqrt instructions: 34.00-40.00\nLongest recurrence chain latency (RecMII): 4.00\n",
        },
        {
          title = "Front-end and detailed OoO resources (UFS)",
          txt = "FE+BE cycles           : 35.32-40.95\nStall cycles           : 22.86-28.49\nRS full (events)       : 0.33-0.32\nPRF_FLOAT full (events): 25.71-32.20\n",
        },
        {
          title = "Cycles summary",
          txt = "Front-end : 12.00\nDispatch  : 15.00\nDIV/SQRT  : 34.00-40.00\nData deps.: 4.00\nOverall L1: 34.00-40.00\n",
        },
        {
          title = "Vectorization ratios",
          txt = "all     : 100%\nload    : 100%\nstore   : NA (no store vectorizable/vectorized instructions)\nmul     : 100%\nadd-sub : 100%\nfma     : 100%\ndiv/sqrt: 100%\nother   : 100%\n",
        },
        {
          title = "Vector efficiency ratios",
          txt = "all     : 45%\nload    : 50%\nstore   : NA (no store vectorizable/vectorized instructions)\nmul     : 50%\nadd-sub : 50%\nfma     : 50%\ndiv/sqrt: 50%\nother   : 35%\n",
        },
        {
          title = "Cycles and memory resources usage",
          txt = "Detected masked instructions: assuming all mask elements are active.\nAssuming all data fit into the L1 cache, each iteration of the binary loop takes 40.00 cycles. At this rate:\n - 2% of peak load performance is reached (3.20 out of 128.00 bytes loaded per cycle (GB/s @ 1GHz))\n",
        },
        {
          title = "Front-end bottlenecks",
          txt = "Found no such bottlenecks.",
        },
        {
          title = "ASM code",
          txt = "In the binary file, the address of the loop is: 401bf0\n\nInstruction                         | Nb FU | P0   | P1   | P2   | P3   | P4 | P5   | P6   | P7 | Latency | Recip. throughput\n-----------------------------------------------------------------------------------------------------------------------------\nVMOVUPS (%RSI,%RBX,4),%YMM16        | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nVSUBPS %YMM6,%YMM16,%YMM16          | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVMOVUPS (%RDX,%RBX,4),%YMM17        | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nVSUBPS %YMM5,%YMM17,%YMM17          | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVMOVUPS (%RCX,%RBX,4),%YMM18        | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nVSUBPS %YMM2,%YMM18,%YMM18          | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVMULPS %YMM16,%YMM16,%YMM19         | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231PS %YMM17,%YMM17,%YMM19    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231PS %YMM18,%YMM18,%YMM19    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCMPPS $0x1,%YMM1,%YMM19,%K1        | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVMOVUPS (%R8,%RBX,4),%YMM20{%K1}{z} | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nVADDPS %YMM27,%YMM19,%YMM21         | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVEXTRACTF32X4 $0x1,%YMM21,%XMM3     | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVCVTPS2PD %XMM3,%YMM3               | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVCVTPS2PD %XMM21,%YMM21             | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVSQRTPD %YMM21,%YMM23               | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-19   | 9-12\nVSQRTPD %YMM3,%YMM24                | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-19   | 9-12\nVMULPD %YMM21,%YMM21,%YMM21         | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVDIVPD %YMM21,%YMM8,%YMM21          | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-14   | 8\nVMULPD %YMM3,%YMM3,%YMM3            | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVMOVAPS %YMM9,%YMM25                | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 0       | 0.25\nVFMADD213PS %YMM10,%YMM19,%YMM25    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD213PS %YMM11,%YMM19,%YMM25    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD213PS %YMM13,%YMM19,%YMM25    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD213PS %YMM14,%YMM19,%YMM25    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD213PS %YMM15,%YMM19,%YMM25    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTPS2PD %XMM25,%YMM26             | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVDIVPD %YMM3,%YMM8,%YMM3            | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-14   | 8\nVFMADD231PD %YMM21,%YMM23,%YMM26    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVEXTRACTF32X4 $0x1,%YMM25,%XMM0     | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVCVTPS2PD %XMM0,%YMM0               | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVFMADD231PD %YMM3,%YMM24,%YMM0      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTPD2PS %YMM26,%XMM3              | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVCVTPD2PS %YMM0,%XMM0               | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVINSERTF128 $0x1,%XMM0,%YMM3,%YMM0  | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVCMPPS $0x1,%YMM19,%YMM22,%K1       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVMULPS %YMM0,%YMM20,%YMM0{%K1}{z}   | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231PS %YMM16,%YMM0,%YMM12     | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231PS %YMM17,%YMM0,%YMM7      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231PS %YMM18,%YMM0,%YMM4      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nADD $0x8,%RBX                       | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0  | 1       | 0.25\nCMP %RDI,%RBX                       | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0  | 1       | 0.25\nJB 401bf0 <Step10_orig+0xa0>        | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0  | 0       | 0.50-1\n",
        },
      },
      header = {
        "9% of peak computational performance is used (6.20 out of 64.00 FLOP per cycle (GFLOPS @ 1GHz))",
      },
      brief = {
      },
      gain = {
        {
          details = "All SSE/AVX instructions are used in vector version (process two or more data elements in vector registers).\n",
          title = "Vectorization",
          txt = "Your loop is vectorized, but using 45% register length (average across all SSE/AVX instructions).\n",
        },
        {
          workaround = "Reduce the number of division or square root instructions:\n - If denominator is constant over iterations, use reciprocal (replace x/y with x*(1/y)). Check precision impact.\n",
          title = "Execution units bottlenecks",
          txt = "Performance is limited by execution of divide and square root operations (the divide/square root unit is a bottleneck).\n\nBy removing all these bottlenecks, you can lower the cost of an iteration from 40.00 to 15.00 cycles (2.67x speedup).\n",
        },
      },
      potential = {
        {
          title = "512-bits vectorization on Skylake SP and Icelake Server",
          txt = "On Gold 5122, 6xxx and Platinum Skylake processors and Icelake Server processors, performance can be improved by using 512-bits vectorization if the number of vectorized loops is high and with high trip count.\n",
        },
        {
          title = "Expensive FP math instructions/calls",
          txt = "Detected performance impact from expensive FP math instructions/calls.\nBy removing/reexpressing them, you can lower the cost of an iteration from 40.00 to 15.00 cycles (2.67x speedup).",
        },
        {
          workaround = "If your loop is irregular, try to remove or hoist conditional structures out of your loop. If it mixes elements of different sizes, try to uniformize them.",
          details = "Vector registers are partially exploited, which is expected if your loop is irregular or mixes elements of different sizes.",
          title = "Masked instructions",
          txt = "Detected masked instructions.",
        },
        {
          workaround = "Try to change order in which elements are evaluated (using parentheses) in arithmetic expressions containing both ADD/SUB and MUL operations to enable your compiler to generate FMA instructions wherever possible.\nFor instance a + b*c is a valid FMA (MUL then ADD).\nHowever (a+b)* c cannot be translated into an FMA (ADD then MUL).",
          title = "FMA",
          txt = "Detected 88 FMA (fused multiply-add) operations.\nPresence of both ADD/SUB and MUL operations.",
        },
      },
    },
  },
  AVG = {
      hint = {
        {
          details = "These instructions generate more than one micro-operation and only one of them can be decoded during a cycle and the extra micro-operations increase pressure on execution units.\n - VCVTPD2PS: 2 occurrences\n - VCVTPS2PD: 4 occurrences\n",
          title = "Complex instructions",
          txt = "Detected COMPLEX INSTRUCTIONS.\n",
        },
        {
          workaround = " - Pass to your compiler a micro-architecture specialization option:\n  * Please read your compiler manual\n - Use vector aligned instructions:\n  1) align your arrays on 64 bytes boundaries: replace { void *p = malloc (size); } with { void *p; posix_memalign (&p, 64, size); }.\n  2) inform your compiler that your arrays are vector aligned: read your compiler manual.\n",
          details = " - VEXTRACTF32X4: 2 occurrences\n - VINSERTF128: 1 occurrences\n",
          title = "Vector unaligned load/store instructions",
          txt = "Detected 3 suboptimal vector unaligned load/store instructions.\n",
        },
        {
          workaround = "Avoid mixing data with different types. In particular, check if the type of constants is the same as array elements. Use double instead of single precision only when/where needed by numerical stability and avoid mixing precision. In C/C++, FP constants are double precision by default and must be suffixed by 'f' to make them single precision.",
          details = " - VCVTPD2PS (FP64 to FP32, SIMD): 2 occurrences\n - VCVTPS2PD (FP32 to FP64, SIMD): 4 occurrences\n",
          title = "Conversion instructions",
          txt = "Detected expensive conversion instructions.",
        },
        {
          title = "Type of elements and instruction set",
          txt = "18 AVX instructions are processing arithmetic or math operations on single precision FP elements in vector mode (eight at a time).\n8 AVX instructions are processing arithmetic or math operations on double precision FP elements in vector mode (four at a time).\n",
        },
        {
          title = "Matching between your loop (in the source code) and the binary loop",
          txt = "The binary loop is composed of 248 FP arithmetical operations:\n - 120: addition or subtraction (88 inside FMA instructions)\n - 112: multiply (88 inside FMA instructions)\n - 8: divide\n - 8: square root\nThe binary loop is loading 128 bytes (32 single precision FP elements).",
        },
        {
          title = "Arithmetic intensity",
          txt = "Arithmetic intensity is 1.94 FP operations per loaded or stored byte.",
        },
      },
      expert = {
        {
          title = "General properties",
          txt = "nb instructions    : 43\nnb uops            : 48\nloop length        : 251\nused x86 registers : 6\nused mmx registers : 0\nused xmm registers : 4\nused ymm registers : 28\nused zmm registers : 0\nnb stack references: 0\nADD-SUB / MUL ratio: 1.00\n",
        },
        {
          title = "Front-end",
          txt = "ASSUMED MACRO FUSION\nFIT IN UOP CACHE\nmicro-operation queue: 12.00 cycles\nfront end            : 12.00 cycles\n",
        },
        {
          title = "Back-end",
          txt = "       | P0    | P1    | P2   | P3   | P4   | P5    | P6   | P7\n-----------------------------------------------------------------\nuops   | 15.00 | 15.00 | 2.00 | 2.00 | 0.00 | 11.00 | 2.00 | 0.00\ncycles | 15.00 | 15.00 | 2.00 | 2.00 | 0.00 | 11.00 | 2.00 | 0.00\n\nCycles executing div or sqrt instructions: 34.00-40.00\nLongest recurrence chain latency (RecMII): 4.00\n",
        },
        {
          title = "Front-end and detailed OoO resources (UFS)",
          txt = "FE+BE cycles           : 35.32-40.95\nStall cycles           : 22.86-28.49\nRS full (events)       : 0.33-0.32\nPRF_FLOAT full (events): 25.71-32.20\n",
        },
        {
          title = "Cycles summary",
          txt = "Front-end : 12.00\nDispatch  : 15.00\nDIV/SQRT  : 34.00-40.00\nData deps.: 4.00\nOverall L1: 34.00-40.00\n",
        },
        {
          title = "Vectorization ratios",
          txt = "all     : 100%\nload    : 100%\nstore   : NA (no store vectorizable/vectorized instructions)\nmul     : 100%\nadd-sub : 100%\nfma     : 100%\ndiv/sqrt: 100%\nother   : 100%\n",
        },
        {
          title = "Vector efficiency ratios",
          txt = "all     : 45%\nload    : 50%\nstore   : NA (no store vectorizable/vectorized instructions)\nmul     : 50%\nadd-sub : 50%\nfma     : 50%\ndiv/sqrt: 50%\nother   : 35%\n",
        },
        {
          title = "Cycles and memory resources usage",
          txt = "Detected masked instructions: assuming all mask elements are active.\nAssuming all data fit into the L1 cache, each iteration of the binary loop takes 40.00 cycles. At this rate:\n - 2% of peak load performance is reached (3.20 out of 128.00 bytes loaded per cycle (GB/s @ 1GHz))\n",
        },
        {
          title = "Front-end bottlenecks",
          txt = "Found no such bottlenecks.",
        },
        {
          title = "ASM code",
          txt = "In the binary file, the address of the loop is: 401bf0\n\nInstruction                         | Nb FU | P0   | P1   | P2   | P3   | P4 | P5   | P6   | P7 | Latency | Recip. throughput\n-----------------------------------------------------------------------------------------------------------------------------\nVMOVUPS (%RSI,%RBX,4),%YMM16        | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nVSUBPS %YMM6,%YMM16,%YMM16          | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVMOVUPS (%RDX,%RBX,4),%YMM17        | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nVSUBPS %YMM5,%YMM17,%YMM17          | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVMOVUPS (%RCX,%RBX,4),%YMM18        | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nVSUBPS %YMM2,%YMM18,%YMM18          | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVMULPS %YMM16,%YMM16,%YMM19         | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231PS %YMM17,%YMM17,%YMM19    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231PS %YMM18,%YMM18,%YMM19    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCMPPS $0x1,%YMM1,%YMM19,%K1        | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVMOVUPS (%R8,%RBX,4),%YMM20{%K1}{z} | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nVADDPS %YMM27,%YMM19,%YMM21         | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVEXTRACTF32X4 $0x1,%YMM21,%XMM3     | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVCVTPS2PD %XMM3,%YMM3               | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVCVTPS2PD %XMM21,%YMM21             | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVSQRTPD %YMM21,%YMM23               | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-19   | 9-12\nVSQRTPD %YMM3,%YMM24                | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-19   | 9-12\nVMULPD %YMM21,%YMM21,%YMM21         | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVDIVPD %YMM21,%YMM8,%YMM21          | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-14   | 8\nVMULPD %YMM3,%YMM3,%YMM3            | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVMOVAPS %YMM9,%YMM25                | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 0       | 0.25\nVFMADD213PS %YMM10,%YMM19,%YMM25    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD213PS %YMM11,%YMM19,%YMM25    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD213PS %YMM13,%YMM19,%YMM25    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD213PS %YMM14,%YMM19,%YMM25    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD213PS %YMM15,%YMM19,%YMM25    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTPS2PD %XMM25,%YMM26             | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVDIVPD %YMM3,%YMM8,%YMM3            | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-14   | 8\nVFMADD231PD %YMM21,%YMM23,%YMM26    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVEXTRACTF32X4 $0x1,%YMM25,%XMM0     | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVCVTPS2PD %XMM0,%YMM0               | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVFMADD231PD %YMM3,%YMM24,%YMM0      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTPD2PS %YMM26,%XMM3              | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVCVTPD2PS %YMM0,%XMM0               | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVINSERTF128 $0x1,%XMM0,%YMM3,%YMM0  | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVCMPPS $0x1,%YMM19,%YMM22,%K1       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVMULPS %YMM0,%YMM20,%YMM0{%K1}{z}   | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231PS %YMM16,%YMM0,%YMM12     | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231PS %YMM17,%YMM0,%YMM7      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231PS %YMM18,%YMM0,%YMM4      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nADD $0x8,%RBX                       | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0  | 1       | 0.25\nCMP %RDI,%RBX                       | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0  | 1       | 0.25\nJB 401bf0 <Step10_orig+0xa0>        | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0  | 0       | 0.50-1\n",
        },
      },
      header = {
        "9% of peak computational performance is used (6.20 out of 64.00 FLOP per cycle (GFLOPS @ 1GHz))",
      },
      brief = {
      },
      gain = {
        {
          details = "All SSE/AVX instructions are used in vector version (process two or more data elements in vector registers).\n",
          title = "Vectorization",
          txt = "Your loop is vectorized, but using 45% register length (average across all SSE/AVX instructions).\n",
        },
        {
          workaround = "Reduce the number of division or square root instructions:\n - If denominator is constant over iterations, use reciprocal (replace x/y with x*(1/y)). Check precision impact.\n",
          title = "Execution units bottlenecks",
          txt = "Performance is limited by execution of divide and square root operations (the divide/square root unit is a bottleneck).\n\nBy removing all these bottlenecks, you can lower the cost of an iteration from 40.00 to 15.00 cycles (2.67x speedup).\n",
        },
      },
      potential = {
        {
          title = "512-bits vectorization on Skylake SP and Icelake Server",
          txt = "On Gold 5122, 6xxx and Platinum Skylake processors and Icelake Server processors, performance can be improved by using 512-bits vectorization if the number of vectorized loops is high and with high trip count.\n",
        },
        {
          title = "Expensive FP math instructions/calls",
          txt = "Detected performance impact from expensive FP math instructions/calls.\nBy removing/reexpressing them, you can lower the cost of an iteration from 40.00 to 15.00 cycles (2.67x speedup).",
        },
        {
          workaround = "If your loop is irregular, try to remove or hoist conditional structures out of your loop. If it mixes elements of different sizes, try to uniformize them.",
          details = "Vector registers are partially exploited, which is expected if your loop is irregular or mixes elements of different sizes.",
          title = "Masked instructions",
          txt = "Detected masked instructions.",
        },
        {
          workaround = "Try to change order in which elements are evaluated (using parentheses) in arithmetic expressions containing both ADD/SUB and MUL operations to enable your compiler to generate FMA instructions wherever possible.\nFor instance a + b*c is a valid FMA (MUL then ADD).\nHowever (a+b)* c cannot be translated into an FMA (ADD then MUL).",
          title = "FMA",
          txt = "Detected 88 FMA (fused multiply-add) operations.\nPresence of both ADD/SUB and MUL operations.",
        },
      },
    },
  common = {
    header = {
      "The loop is defined in /home/kcamus/qaas_runs/169-401-3406/intel/HACCmk/build/HACCmk/src/Step10_orig.c:19-35.\n",
      "The related source loop is not unrolled or unrolled with no peel/tail loop.",
    },
    nb_paths = 1,
  },
}
