_cqa_text_report = {
  paths = {
    {
      hint = {
        {
          details = "These instructions generate more than one micro-operation and only one of them can be decoded during a cycle and the extra micro-operations increase pressure on execution units.\n - VCVTPD2PS: 2 occurrences\n - VCVTPS2PD: 4 occurrences\n - VZEROUPPER: 1 occurrences\n",
          title = "Complex instructions",
          txt = "Detected COMPLEX INSTRUCTIONS.\n",
        },
        {
          workaround = " - Pass to your compiler a micro-architecture specialization option:\n  * Please read your compiler manual\n - Use vector aligned instructions:\n  1) align your arrays on 64 bytes boundaries: replace { void *p = malloc (size); } with { void *p; posix_memalign (&p, 64, size); }.\n  2) inform your compiler that your arrays are vector aligned: read your compiler manual.\n",
          details = " - VEXTRACTF128: 8 occurrences\n - VINSERTF128: 1 occurrences\n",
          title = "Vector unaligned load/store instructions",
          txt = "Detected 9 suboptimal vector unaligned load/store instructions.\n",
        },
        {
          workaround = "Avoid mixing data with different types. In particular, check if the type of constants is the same as array elements. Use double instead of single precision only when/where needed by numerical stability and avoid mixing precision. In C/C++, FP constants are double precision by default and must be suffixed by 'f' to make them single precision.",
          details = " - VCVTPD2PS (FP64 to FP32, SIMD): 2 occurrences\n - VCVTPS2PD (FP32 to FP64, SIMD): 4 occurrences\n",
          title = "Conversion instructions",
          txt = "Detected expensive conversion instructions.",
        },
        {
          title = "Type of elements and instruction set",
          txt = "9 SSE or AVX instructions are processing arithmetic or math operations on single precision FP elements in scalar mode (one at a time).\n12 SSE or AVX instructions are processing arithmetic or math operations on single precision FP elements in vector mode (four at a time).\n18 AVX instructions are processing arithmetic or math operations on single precision FP elements in vector mode (eight at a time).\n8 AVX instructions are processing arithmetic or math operations on double precision FP elements in vector mode (four at a time).\n",
        },
        {
          title = "Matching between your function (in the source code) and the binary function",
          txt = "The binary function is composed of 281 FP arithmetical operations:\n - 153: addition or subtraction (64 inside FMA instructions)\n - 112: multiply (64 inside FMA instructions)\n - 8: divide\n - 8: square root\nThe binary function is loading 272 bytes (68 single precision FP elements).\nThe binary function is storing 12 bytes (3 single precision FP elements).",
        },
        {
          title = "Arithmetic intensity",
          txt = "Arithmetic intensity is 0.99 FP operations per loaded or stored byte.",
        },
      },
      expert = {
        {
          title = "General properties",
          txt = "nb instructions    : 143\nnb uops            : 150\nloop length        : 741\nused x86 registers : 12\nused mmx registers : 0\nused xmm registers : 12\nused ymm registers : 16\nused zmm registers : 0\nnb stack references: 2\nADD-SUB / MUL ratio: 3.57\n",
        },
        {
          title = "Front-end",
          txt = "MACRO FUSION NOT POSSIBLE\nFIT IN UOP CACHE\nmicro-operation queue: 37.50 cycles\nfront end            : 37.50 cycles\n",
        },
        {
          title = "Back-end",
          txt = "       | P0    | P1    | P2    | P3    | P4   | P5    | P6    | P7\n--------------------------------------------------------------------\nuops   | 27.00 | 27.00 | 12.00 | 12.00 | 5.00 | 43.00 | 10.00 | 6.00\ncycles | 27.00 | 27.00 | 12.00 | 12.00 | 5.00 | 43.00 | 10.00 | 6.00\n\nCycles executing div or sqrt instructions: 34.00-40.00\n",
        },
        {
          title = "Front-end and detailed OoO resources (UFS)",
          txt = "FE+BE cycles    : 142.17-149.17\nStall cycles    : 104.95-111.95\nRS full (events): 128.60-135.60\n",
        },
        {
          title = "Cycles summary",
          txt = "Front-end : 37.50\nDispatch  : 43.00\nDIV/SQRT  : 34.00-40.00\nOverall L1: 43.00\n",
        },
        {
          title = "Vectorization ratios",
          txt = "INT\nall    : 54%\nload   : 100%\nstore  : NA (no store vectorizable/vectorized instructions)\nmul    : NA (no mul vectorizable/vectorized instructions)\nadd-sub: 100%\nfma    : NA (no fma vectorizable/vectorized instructions)\nother  : 44%\nFP\nall     : 71%\nload    : 50%\nstore   : 0%\nmul     : 100%\nadd-sub : 64%\nfma     : 100%\ndiv/sqrt: 100%\nother   : 67%\nINT+FP\nall     : 70%\nload    : 55%\nstore   : 0%\nmul     : 100%\nadd-sub : 66%\nfma     : 100%\ndiv/sqrt: 100%\nother   : 64%\n",
        },
        {
          title = "Vector efficiency ratios",
          txt = "INT\nall    : 27%\nload   : 50%\nstore  : NA (no store vectorizable/vectorized instructions)\nmul    : NA (no mul vectorizable/vectorized instructions)\nadd-sub: 50%\nfma    : NA (no fma vectorizable/vectorized instructions)\nother  : 22%\nFP\nall     : 26%\nload    : 28%\nstore   : 6%\nmul     : 50%\nadd-sub : 22%\nfma     : 50%\ndiv/sqrt: 50%\nother   : 19%\nINT+FP\nall     : 26%\nload    : 30%\nstore   : 6%\nmul     : 50%\nadd-sub : 24%\nfma     : 50%\ndiv/sqrt: 50%\nother   : 19%\n",
        },
        {
          title = "Cycles and memory resources usage",
          txt = "Detected masked instructions: assuming all mask elements are active.\nAssuming all data fit into the L1 cache, each call to the function takes 43.00 cycles. At this rate:\n - 4% of peak load performance is reached (6.33 out of 128.00 bytes loaded per cycle (GB/s @ 1GHz))\n - 0% of peak store performance is reached (0.28 out of 64.00 bytes stored per cycle (GB/s @ 1GHz))\n",
        },
        {
          title = "Front-end bottlenecks",
          txt = "Found no such bottlenecks.",
        },
        {
          title = "ASM code",
          txt = "In the binary file, the address of the function is: 401b50\n\nInstruction                                 | Nb FU | P0   | P1   | P2   | P3   | P4 | P5   | P6   | P7   | Latency | Recip. throughput\n---------------------------------------------------------------------------------------------------------------------------------------\nPUSH %RBP                                   | 1     | 0    | 0    | 0.33 | 0.33 | 1  | 0    | 0    | 0.33 | 3       | 1\nMOV %RSP,%RBP                               | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nPUSH %RBX                                   | 1     | 0    | 0    | 0.33 | 0.33 | 1  | 0    | 0    | 0.33 | 3       | 1\nMOV 0x18(%RBP),%R10                         | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 4-5     | 0.50\nMOV 0x10(%RBP),%R11                         | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 4-5     | 0.50\nTEST %EDI,%EDI                              | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0    | 1       | 0.25\nJLE 401d4f <Step10_orig+0x1ff>              | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0    | 0       | 0.50-1\nMOV %EDI,%EAX                               | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nMOV $-0x8,%EDI                              | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0    | 1       | 0.25\nAND %RAX,%RDI                               | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0    | 1       | 0.25\nJE 401d60 <Step10_orig+0x210>               | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0    | 0       | 0.50-1\nVBROADCASTSS %XMM0,%YMM6                    | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVBROADCASTSS %XMM1,%YMM5                    | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVBROADCASTSS %XMM2,%YMM2                    | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVBROADCASTSS %XMM3,%YMM1                    | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVBROADCASTSS %XMM4,%YMM27                   | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVXORPS %XMM22,%XMM22,%XMM22                 | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVBROADCASTSD 0x669a(%RIP),%YMM8             | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5       | 0.50\nVBROADCASTSS 0x6699(%RIP),%YMM9             | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5       | 0.50\nVBROADCASTSS 0x6694(%RIP),%YMM10            | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5       | 0.50\nVBROADCASTSS 0x668f(%RIP),%YMM11            | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5       | 0.50\nVBROADCASTSS 0x668a(%RIP),%YMM13            | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5       | 0.50\nVBROADCASTSS 0x6685(%RIP),%YMM14            | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5       | 0.50\nXOR %EBX,%EBX                               | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVBROADCASTSS 0x667e(%RIP),%YMM15            | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5       | 0.50\nVXORPS %XMM12,%XMM12,%XMM12                 | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVXORPS %XMM7,%XMM7,%XMM7                    | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVXORPS %XMM4,%XMM4,%XMM4                    | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nNOPW %CS:(%RAX,%RAX,1)                      | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVEXTRACTF128 $0x1,%YMM12,%XMM0              | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVADDPS %XMM0,%XMM12,%XMM0                   | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVPERMILPD $0x1,%XMM0,%XMM3                  | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDPS %XMM3,%XMM0,%XMM0                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMOVSHDUP %XMM0,%XMM3                       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDSS %XMM3,%XMM0,%XMM3                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVEXTRACTF128 $0x1,%YMM7,%XMM0               | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVADDPS %XMM0,%XMM7,%XMM0                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVPERMILPD $0x1,%XMM0,%XMM7                  | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDPS %XMM7,%XMM0,%XMM0                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMOVSHDUP %XMM0,%XMM7                       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDSS %XMM7,%XMM0,%XMM7                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVEXTRACTF128 $0x1,%YMM4,%XMM0               | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVADDPS %XMM0,%XMM4,%XMM0                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVPERMILPD $0x1,%XMM0,%XMM4                  | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDPS %XMM4,%XMM0,%XMM0                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMOVSHDUP %XMM0,%XMM4                       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDSS %XMM4,%XMM0,%XMM4                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVPBROADCASTQ %RAX,%YMM8                     | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nCMP %RAX,%RDI                               | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0    | 1       | 0.25\nJNE 401d8e <Step10_orig+0x23e>              | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0    | 0       | 0.50-1\nJMP 401f15 <Step10_orig+0x3c5>              | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 1    | 0    | 0       | 1-2\nVXORPS %XMM3,%XMM3,%XMM3                    | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVXORPS %XMM7,%XMM7,%XMM7                    | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVXORPS %XMM4,%XMM4,%XMM4                    | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nJMP 401f15 <Step10_orig+0x3c5>              | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 1    | 0    | 0       | 1-2\nVPBROADCASTQ %RAX,%YMM8                     | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVBROADCASTSS %XMM0,%YMM6                    | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVBROADCASTSS %XMM1,%YMM5                    | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVBROADCASTSS %XMM2,%YMM2                    | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVBROADCASTSS %XMM3,%YMM1                    | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVBROADCASTSS %XMM4,%YMM27                   | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVXORPS %XMM4,%XMM4,%XMM4                    | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nXOR %EDI,%EDI                               | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVXORPS %XMM7,%XMM7,%XMM7                    | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVXORPS %XMM3,%XMM3,%XMM3                    | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVPBROADCASTQ %RDI,%YMM9                     | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVPADDQ 0x64c4(%RIP),%YMM9,%YMM10            | 1     | 0.33 | 0.33 | 0.50 | 0.50 | 0  | 0.33 | 0    | 0    | 1       | 0.50\nVPADDQ 0x64dc(%RIP),%YMM9,%YMM9             | 1     | 0.33 | 0.33 | 0.50 | 0.50 | 0  | 0.33 | 0    | 0    | 1       | 0.50\nVPCMPLTUQ %YMM8,%YMM9,%K0\nVPCMPLTUQ %YMM8,%YMM10,%K1\nKSHIFTLB $0x4,%K1,%K1                       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 4       | 1\nKORB %K1,%K0,%K1                            | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 1       | 1\nVMOVUPS (%RSI,%RDI,4),%YMM8{%K1}{z}         | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5-6     | 0.50\nVSUBPS %YMM6,%YMM8,%YMM6                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMOVUPS (%RDX,%RDI,4),%YMM8{%K1}{z}         | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5-6     | 0.50\nVSUBPS %YMM5,%YMM8,%YMM5                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMOVUPS (%RCX,%RDI,4),%YMM8{%K1}{z}         | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5-6     | 0.50\nVSUBPS %YMM2,%YMM8,%YMM2                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMULPS %YMM6,%YMM6,%YMM8                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVFMADD231PS %YMM5,%YMM5,%YMM8               | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVFMADD231PS %YMM2,%YMM2,%YMM8               | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVCMPPS $0x1,%YMM1,%YMM8,%K2{%K1}            | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVMOVUPS (%R8,%RDI,4),%YMM10{%K2}{z}         | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5-6     | 0.50\nVPXOR %XMM9,%XMM9,%XMM9                     | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVADDPS %YMM27,%YMM8,%YMM0                   | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVEXTRACTF128 $0x1,%YMM0,%XMM1               | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVCVTPS2PD %XMM1,%YMM1                       | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0    | 7       | 1\nVCVTPS2PD %XMM0,%YMM0                       | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0    | 7       | 1\nVSQRTPD %YMM0,%YMM11                        | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 13-19   | 9-12\nVSQRTPD %YMM1,%YMM12                        | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 13-19   | 9-12\nVBROADCASTSD 0x6415(%RIP),%YMM13            | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5       | 0.50\nVMULPD %YMM0,%YMM0,%YMM0                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVDIVPD %YMM0,%YMM13,%YMM0                   | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 13-14   | 8\nVMULPD %YMM1,%YMM1,%YMM1                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVDIVPD %YMM1,%YMM13,%YMM1                   | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 13-14   | 8\nVBROADCASTSS 0x6404(%RIP),%YMM13            | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5       | 0.50\nVFMADD213PS 0x63fe(%RIP){1to8},%YMM8,%YMM13 | 1     | 0.50 | 0.50 | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 4       | 0.50\nVFMADD213PS 0x63f8(%RIP){1to8},%YMM8,%YMM13 | 1     | 0.50 | 0.50 | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 4       | 0.50\nVFMADD213PS 0x63f2(%RIP){1to8},%YMM8,%YMM13 | 1     | 0.50 | 0.50 | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 4       | 0.50\nVFMADD213PS 0x63ec(%RIP){1to8},%YMM8,%YMM13 | 1     | 0.50 | 0.50 | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 4       | 0.50\nVFMADD213PS 0x63e6(%RIP){1to8},%YMM8,%YMM13 | 1     | 0.50 | 0.50 | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 4       | 0.50\nVCVTPS2PD %XMM13,%YMM14                     | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0    | 7       | 1\nVFMADD231PD %YMM0,%YMM11,%YMM14             | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVEXTRACTF128 $0x1,%YMM13,%XMM0              | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVCVTPS2PD %XMM0,%YMM0                       | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0    | 7       | 1\nVCVTPD2PS %YMM14,%XMM11                     | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0    | 7       | 1\nVFMADD231PD %YMM1,%YMM12,%YMM0              | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVCVTPD2PS %YMM0,%XMM0                       | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0    | 7       | 1\nVINSERTF128 $0x1,%XMM0,%YMM11,%YMM0         | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVCMPPS $0x1,%YMM8,%YMM9,%K2                 | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVMULPS %YMM0,%YMM10,%YMM0{%K2}{z}           | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMULPS %YMM6,%YMM0,%YMM1{%K1}{z}            | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMULPS %YMM5,%YMM0,%YMM5{%K1}{z}            | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMULPS %YMM2,%YMM0,%YMM0{%K1}{z}            | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVEXTRACTF128 $0x1,%YMM1,%XMM2               | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVADDPS %XMM2,%XMM1,%XMM1                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVPERMILPD $0x1,%XMM1,%XMM2                  | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDPS %XMM2,%XMM1,%XMM1                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMOVSHDUP %XMM1,%XMM2                       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDSS %XMM2,%XMM1,%XMM1                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVADDSS %XMM1,%XMM3,%XMM3                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVEXTRACTF128 $0x1,%YMM5,%XMM1               | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVADDPS %XMM1,%XMM5,%XMM1                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVPERMILPD $0x1,%XMM1,%XMM2                  | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDPS %XMM2,%XMM1,%XMM1                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMOVSHDUP %XMM1,%XMM2                       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDSS %XMM2,%XMM1,%XMM1                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVADDSS %XMM1,%XMM7,%XMM7                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVEXTRACTF128 $0x1,%YMM0,%XMM1               | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVADDPS %XMM1,%XMM0,%XMM0                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVPERMILPD $0x1,%XMM0,%XMM1                  | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDPS %XMM1,%XMM0,%XMM0                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMOVSHDUP %XMM0,%XMM1                       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDSS %XMM1,%XMM0,%XMM0                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVADDSS %XMM0,%XMM4,%XMM4                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMOVSS %XMM3,(%R9)                          | 1     | 0    | 0    | 0.33 | 0.33 | 1  | 0    | 0    | 0.33 | 3       | 1\nVMOVSS %XMM7,(%R11)                         | 1     | 0    | 0    | 0.33 | 0.33 | 1  | 0    | 0    | 0.33 | 3       | 1\nVMOVSS %XMM4,(%R10)                         | 1     | 0    | 0    | 0.33 | 0.33 | 1  | 0    | 0    | 0.33 | 3       | 1\nPOP %RBX                                    | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 2       | 0.50\nPOP %RBP                                    | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 2       | 0.50\nVZEROUPPER                                  | 4     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 1\nRET                                         | 1     | 0    | 0    | 0.33 | 0.33 | 0  | 0    | 1    | 0.33 | 0       | 1\nNOPW (%RAX,%RAX,1)                          | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\n",
        },
      },
      header = {
        "Warnings:\n - The number of fused uops of the instruction [VPCMPLTUQ	%YMM8,%YMM9,%K0] is unknown\n - The number of fused uops of the instruction [VPCMPLTUQ	%YMM8,%YMM10,%K1] is unknown\n",
        "10% of peak computational performance is used (6.53 out of 64.00 FLOP per cycle (GFLOPS @ 1GHz))",
      },
      brief = {
      },
      gain = {
        {
          workaround = "Read the \"512-bits vectorization on Skylake SP\" report at \"Potential\" confidence level.",
          details = "70% of SSE/AVX instructions are used in vector version (process two or more data elements in vector registers):\n - 55% of SSE/AVX loads are used in vector version.\n - 0% of SSE/AVX stores are used in vector version.\n - 66% of SSE/AVX addition or subtraction instructions are used in vector version.\n - 64% of SSE/AVX instructions that are not load, store, addition, subtraction nor multiply instructions are used in vector version.\n",
          title = "Vectorization",
          txt = "Your function is partially vectorized.\nOnly 26% of vector register length is used (average across all SSE/AVX instructions).\n",
        },
        {
          workaround = "Reduce the number of FP multiply/FMA instructions",
          title = "Execution units bottlenecks",
          txt = "Performance is limited by execution of FP multiply or FMA (fused multiply-add) operations (the FP multiply/FMA unit is a bottleneck).\n",
        },
      },
      potential = {
        {
          title = "512-bits vectorization on Skylake SP and Icelake Server",
          txt = "On Gold 5122, 6xxx and Platinum Skylake processors and Icelake Server processors, performance can be improved by using 512-bits vectorization if the number of vectorized loops is high and with high trip count.\n",
        },
        {
          workaround = "If your function is irregular, try to remove or hoist conditional structures out of your function. If it mixes elements of different sizes, try to uniformize them.",
          details = "Vector registers are partially exploited, which is expected if your function is irregular or mixes elements of different sizes.",
          title = "Masked instructions",
          txt = "Detected masked instructions.",
        },
        {
          workaround = "Try to change order in which elements are evaluated (using parentheses) in arithmetic expressions containing both ADD/SUB and MUL operations to enable your compiler to generate FMA instructions wherever possible.\nFor instance a + b*c is a valid FMA (MUL then ADD).\nHowever (a+b)* c cannot be translated into an FMA (ADD then MUL).",
          title = "FMA",
          txt = "Detected 64 FMA (fused multiply-add) operations.\nPresence of both ADD/SUB and MUL operations.",
        },
      },
    },
  },
  AVG = {
      hint = {
        {
          details = "These instructions generate more than one micro-operation and only one of them can be decoded during a cycle and the extra micro-operations increase pressure on execution units.\n - VCVTPD2PS: 2 occurrences\n - VCVTPS2PD: 4 occurrences\n - VZEROUPPER: 1 occurrences\n",
          title = "Complex instructions",
          txt = "Detected COMPLEX INSTRUCTIONS.\n",
        },
        {
          workaround = " - Pass to your compiler a micro-architecture specialization option:\n  * Please read your compiler manual\n - Use vector aligned instructions:\n  1) align your arrays on 64 bytes boundaries: replace { void *p = malloc (size); } with { void *p; posix_memalign (&p, 64, size); }.\n  2) inform your compiler that your arrays are vector aligned: read your compiler manual.\n",
          details = " - VEXTRACTF128: 8 occurrences\n - VINSERTF128: 1 occurrences\n",
          title = "Vector unaligned load/store instructions",
          txt = "Detected 9 suboptimal vector unaligned load/store instructions.\n",
        },
        {
          workaround = "Avoid mixing data with different types. In particular, check if the type of constants is the same as array elements. Use double instead of single precision only when/where needed by numerical stability and avoid mixing precision. In C/C++, FP constants are double precision by default and must be suffixed by 'f' to make them single precision.",
          details = " - VCVTPD2PS (FP64 to FP32, SIMD): 2 occurrences\n - VCVTPS2PD (FP32 to FP64, SIMD): 4 occurrences\n",
          title = "Conversion instructions",
          txt = "Detected expensive conversion instructions.",
        },
        {
          title = "Type of elements and instruction set",
          txt = "9 SSE or AVX instructions are processing arithmetic or math operations on single precision FP elements in scalar mode (one at a time).\n12 SSE or AVX instructions are processing arithmetic or math operations on single precision FP elements in vector mode (four at a time).\n18 AVX instructions are processing arithmetic or math operations on single precision FP elements in vector mode (eight at a time).\n8 AVX instructions are processing arithmetic or math operations on double precision FP elements in vector mode (four at a time).\n",
        },
        {
          title = "Matching between your function (in the source code) and the binary function",
          txt = "The binary function is composed of 281 FP arithmetical operations:\n - 153: addition or subtraction (64 inside FMA instructions)\n - 112: multiply (64 inside FMA instructions)\n - 8: divide\n - 8: square root\nThe binary function is loading 272 bytes (68 single precision FP elements).\nThe binary function is storing 12 bytes (3 single precision FP elements).",
        },
        {
          title = "Arithmetic intensity",
          txt = "Arithmetic intensity is 0.99 FP operations per loaded or stored byte.",
        },
      },
      expert = {
        {
          title = "General properties",
          txt = "nb instructions    : 143\nnb uops            : 150\nloop length        : 741\nused x86 registers : 12\nused mmx registers : 0\nused xmm registers : 12\nused ymm registers : 16\nused zmm registers : 0\nnb stack references: 2\nADD-SUB / MUL ratio: 3.57\n",
        },
        {
          title = "Front-end",
          txt = "MACRO FUSION NOT POSSIBLE\nFIT IN UOP CACHE\nmicro-operation queue: 37.50 cycles\nfront end            : 37.50 cycles\n",
        },
        {
          title = "Back-end",
          txt = "       | P0    | P1    | P2    | P3    | P4   | P5    | P6    | P7\n--------------------------------------------------------------------\nuops   | 27.00 | 27.00 | 12.00 | 12.00 | 5.00 | 43.00 | 10.00 | 6.00\ncycles | 27.00 | 27.00 | 12.00 | 12.00 | 5.00 | 43.00 | 10.00 | 6.00\n\nCycles executing div or sqrt instructions: 34.00-40.00\n",
        },
        {
          title = "Front-end and detailed OoO resources (UFS)",
          txt = "FE+BE cycles    : 142.17-149.17\nStall cycles    : 104.95-111.95\nRS full (events): 128.60-135.60\n",
        },
        {
          title = "Cycles summary",
          txt = "Front-end : 37.50\nDispatch  : 43.00\nDIV/SQRT  : 34.00-40.00\nOverall L1: 43.00\n",
        },
        {
          title = "Vectorization ratios",
          txt = "INT\nall    : 54%\nload   : 100%\nstore  : NA (no store vectorizable/vectorized instructions)\nmul    : NA (no mul vectorizable/vectorized instructions)\nadd-sub: 100%\nfma    : NA (no fma vectorizable/vectorized instructions)\nother  : 44%\nFP\nall     : 71%\nload    : 50%\nstore   : 0%\nmul     : 100%\nadd-sub : 64%\nfma     : 100%\ndiv/sqrt: 100%\nother   : 67%\nINT+FP\nall     : 70%\nload    : 55%\nstore   : 0%\nmul     : 100%\nadd-sub : 66%\nfma     : 100%\ndiv/sqrt: 100%\nother   : 64%\n",
        },
        {
          title = "Vector efficiency ratios",
          txt = "INT\nall    : 27%\nload   : 50%\nstore  : NA (no store vectorizable/vectorized instructions)\nmul    : NA (no mul vectorizable/vectorized instructions)\nadd-sub: 50%\nfma    : NA (no fma vectorizable/vectorized instructions)\nother  : 22%\nFP\nall     : 26%\nload    : 28%\nstore   : 6%\nmul     : 50%\nadd-sub : 22%\nfma     : 50%\ndiv/sqrt: 50%\nother   : 19%\nINT+FP\nall     : 26%\nload    : 30%\nstore   : 6%\nmul     : 50%\nadd-sub : 24%\nfma     : 50%\ndiv/sqrt: 50%\nother   : 19%\n",
        },
        {
          title = "Cycles and memory resources usage",
          txt = "Detected masked instructions: assuming all mask elements are active.\nAssuming all data fit into the L1 cache, each call to the function takes 43.00 cycles. At this rate:\n - 4% of peak load performance is reached (6.33 out of 128.00 bytes loaded per cycle (GB/s @ 1GHz))\n - 0% of peak store performance is reached (0.28 out of 64.00 bytes stored per cycle (GB/s @ 1GHz))\n",
        },
        {
          title = "Front-end bottlenecks",
          txt = "Found no such bottlenecks.",
        },
        {
          title = "ASM code",
          txt = "In the binary file, the address of the function is: 401b50\n\nInstruction                                 | Nb FU | P0   | P1   | P2   | P3   | P4 | P5   | P6   | P7   | Latency | Recip. throughput\n---------------------------------------------------------------------------------------------------------------------------------------\nPUSH %RBP                                   | 1     | 0    | 0    | 0.33 | 0.33 | 1  | 0    | 0    | 0.33 | 3       | 1\nMOV %RSP,%RBP                               | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nPUSH %RBX                                   | 1     | 0    | 0    | 0.33 | 0.33 | 1  | 0    | 0    | 0.33 | 3       | 1\nMOV 0x18(%RBP),%R10                         | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 4-5     | 0.50\nMOV 0x10(%RBP),%R11                         | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 4-5     | 0.50\nTEST %EDI,%EDI                              | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0    | 1       | 0.25\nJLE 401d4f <Step10_orig+0x1ff>              | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0    | 0       | 0.50-1\nMOV %EDI,%EAX                               | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nMOV $-0x8,%EDI                              | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0    | 1       | 0.25\nAND %RAX,%RDI                               | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0    | 1       | 0.25\nJE 401d60 <Step10_orig+0x210>               | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0    | 0       | 0.50-1\nVBROADCASTSS %XMM0,%YMM6                    | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVBROADCASTSS %XMM1,%YMM5                    | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVBROADCASTSS %XMM2,%YMM2                    | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVBROADCASTSS %XMM3,%YMM1                    | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVBROADCASTSS %XMM4,%YMM27                   | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVXORPS %XMM22,%XMM22,%XMM22                 | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVBROADCASTSD 0x669a(%RIP),%YMM8             | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5       | 0.50\nVBROADCASTSS 0x6699(%RIP),%YMM9             | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5       | 0.50\nVBROADCASTSS 0x6694(%RIP),%YMM10            | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5       | 0.50\nVBROADCASTSS 0x668f(%RIP),%YMM11            | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5       | 0.50\nVBROADCASTSS 0x668a(%RIP),%YMM13            | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5       | 0.50\nVBROADCASTSS 0x6685(%RIP),%YMM14            | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5       | 0.50\nXOR %EBX,%EBX                               | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVBROADCASTSS 0x667e(%RIP),%YMM15            | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5       | 0.50\nVXORPS %XMM12,%XMM12,%XMM12                 | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVXORPS %XMM7,%XMM7,%XMM7                    | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVXORPS %XMM4,%XMM4,%XMM4                    | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nNOPW %CS:(%RAX,%RAX,1)                      | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVEXTRACTF128 $0x1,%YMM12,%XMM0              | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVADDPS %XMM0,%XMM12,%XMM0                   | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVPERMILPD $0x1,%XMM0,%XMM3                  | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDPS %XMM3,%XMM0,%XMM0                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMOVSHDUP %XMM0,%XMM3                       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDSS %XMM3,%XMM0,%XMM3                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVEXTRACTF128 $0x1,%YMM7,%XMM0               | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVADDPS %XMM0,%XMM7,%XMM0                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVPERMILPD $0x1,%XMM0,%XMM7                  | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDPS %XMM7,%XMM0,%XMM0                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMOVSHDUP %XMM0,%XMM7                       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDSS %XMM7,%XMM0,%XMM7                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVEXTRACTF128 $0x1,%YMM4,%XMM0               | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVADDPS %XMM0,%XMM4,%XMM0                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVPERMILPD $0x1,%XMM0,%XMM4                  | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDPS %XMM4,%XMM0,%XMM0                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMOVSHDUP %XMM0,%XMM4                       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDSS %XMM4,%XMM0,%XMM4                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVPBROADCASTQ %RAX,%YMM8                     | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nCMP %RAX,%RDI                               | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0    | 1       | 0.25\nJNE 401d8e <Step10_orig+0x23e>              | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0    | 0       | 0.50-1\nJMP 401f15 <Step10_orig+0x3c5>              | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 1    | 0    | 0       | 1-2\nVXORPS %XMM3,%XMM3,%XMM3                    | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVXORPS %XMM7,%XMM7,%XMM7                    | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVXORPS %XMM4,%XMM4,%XMM4                    | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nJMP 401f15 <Step10_orig+0x3c5>              | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 1    | 0    | 0       | 1-2\nVPBROADCASTQ %RAX,%YMM8                     | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVBROADCASTSS %XMM0,%YMM6                    | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVBROADCASTSS %XMM1,%YMM5                    | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVBROADCASTSS %XMM2,%YMM2                    | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVBROADCASTSS %XMM3,%YMM1                    | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVBROADCASTSS %XMM4,%YMM27                   | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVXORPS %XMM4,%XMM4,%XMM4                    | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nXOR %EDI,%EDI                               | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVXORPS %XMM7,%XMM7,%XMM7                    | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVXORPS %XMM3,%XMM3,%XMM3                    | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVPBROADCASTQ %RDI,%YMM9                     | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVPADDQ 0x64c4(%RIP),%YMM9,%YMM10            | 1     | 0.33 | 0.33 | 0.50 | 0.50 | 0  | 0.33 | 0    | 0    | 1       | 0.50\nVPADDQ 0x64dc(%RIP),%YMM9,%YMM9             | 1     | 0.33 | 0.33 | 0.50 | 0.50 | 0  | 0.33 | 0    | 0    | 1       | 0.50\nVPCMPLTUQ %YMM8,%YMM9,%K0\nVPCMPLTUQ %YMM8,%YMM10,%K1\nKSHIFTLB $0x4,%K1,%K1                       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 4       | 1\nKORB %K1,%K0,%K1                            | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 1       | 1\nVMOVUPS (%RSI,%RDI,4),%YMM8{%K1}{z}         | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5-6     | 0.50\nVSUBPS %YMM6,%YMM8,%YMM6                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMOVUPS (%RDX,%RDI,4),%YMM8{%K1}{z}         | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5-6     | 0.50\nVSUBPS %YMM5,%YMM8,%YMM5                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMOVUPS (%RCX,%RDI,4),%YMM8{%K1}{z}         | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5-6     | 0.50\nVSUBPS %YMM2,%YMM8,%YMM2                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMULPS %YMM6,%YMM6,%YMM8                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVFMADD231PS %YMM5,%YMM5,%YMM8               | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVFMADD231PS %YMM2,%YMM2,%YMM8               | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVCMPPS $0x1,%YMM1,%YMM8,%K2{%K1}            | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVMOVUPS (%R8,%RDI,4),%YMM10{%K2}{z}         | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5-6     | 0.50\nVPXOR %XMM9,%XMM9,%XMM9                     | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\nVADDPS %YMM27,%YMM8,%YMM0                   | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVEXTRACTF128 $0x1,%YMM0,%XMM1               | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVCVTPS2PD %XMM1,%YMM1                       | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0    | 7       | 1\nVCVTPS2PD %XMM0,%YMM0                       | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0    | 7       | 1\nVSQRTPD %YMM0,%YMM11                        | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 13-19   | 9-12\nVSQRTPD %YMM1,%YMM12                        | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 13-19   | 9-12\nVBROADCASTSD 0x6415(%RIP),%YMM13            | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5       | 0.50\nVMULPD %YMM0,%YMM0,%YMM0                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVDIVPD %YMM0,%YMM13,%YMM0                   | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 13-14   | 8\nVMULPD %YMM1,%YMM1,%YMM1                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVDIVPD %YMM1,%YMM13,%YMM1                   | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 13-14   | 8\nVBROADCASTSS 0x6404(%RIP),%YMM13            | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 5       | 0.50\nVFMADD213PS 0x63fe(%RIP){1to8},%YMM8,%YMM13 | 1     | 0.50 | 0.50 | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 4       | 0.50\nVFMADD213PS 0x63f8(%RIP){1to8},%YMM8,%YMM13 | 1     | 0.50 | 0.50 | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 4       | 0.50\nVFMADD213PS 0x63f2(%RIP){1to8},%YMM8,%YMM13 | 1     | 0.50 | 0.50 | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 4       | 0.50\nVFMADD213PS 0x63ec(%RIP){1to8},%YMM8,%YMM13 | 1     | 0.50 | 0.50 | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 4       | 0.50\nVFMADD213PS 0x63e6(%RIP){1to8},%YMM8,%YMM13 | 1     | 0.50 | 0.50 | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 4       | 0.50\nVCVTPS2PD %XMM13,%YMM14                     | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0    | 7       | 1\nVFMADD231PD %YMM0,%YMM11,%YMM14             | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVEXTRACTF128 $0x1,%YMM13,%XMM0              | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVCVTPS2PD %XMM0,%YMM0                       | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0    | 7       | 1\nVCVTPD2PS %YMM14,%XMM11                     | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0    | 7       | 1\nVFMADD231PD %YMM1,%YMM12,%YMM0              | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVCVTPD2PS %YMM0,%XMM0                       | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0    | 7       | 1\nVINSERTF128 $0x1,%XMM0,%YMM11,%YMM0         | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVCMPPS $0x1,%YMM8,%YMM9,%K2                 | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVMULPS %YMM0,%YMM10,%YMM0{%K2}{z}           | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMULPS %YMM6,%YMM0,%YMM1{%K1}{z}            | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMULPS %YMM5,%YMM0,%YMM5{%K1}{z}            | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMULPS %YMM2,%YMM0,%YMM0{%K1}{z}            | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVEXTRACTF128 $0x1,%YMM1,%XMM2               | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVADDPS %XMM2,%XMM1,%XMM1                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVPERMILPD $0x1,%XMM1,%XMM2                  | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDPS %XMM2,%XMM1,%XMM1                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMOVSHDUP %XMM1,%XMM2                       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDSS %XMM2,%XMM1,%XMM1                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVADDSS %XMM1,%XMM3,%XMM3                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVEXTRACTF128 $0x1,%YMM5,%XMM1               | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVADDPS %XMM1,%XMM5,%XMM1                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVPERMILPD $0x1,%XMM1,%XMM2                  | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDPS %XMM2,%XMM1,%XMM1                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMOVSHDUP %XMM1,%XMM2                       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDSS %XMM2,%XMM1,%XMM1                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVADDSS %XMM1,%XMM7,%XMM7                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVEXTRACTF128 $0x1,%YMM0,%XMM1               | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 3       | 1\nVADDPS %XMM1,%XMM0,%XMM0                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVPERMILPD $0x1,%XMM0,%XMM1                  | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDPS %XMM1,%XMM0,%XMM0                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMOVSHDUP %XMM0,%XMM1                       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0    | 1       | 1\nVADDSS %XMM1,%XMM0,%XMM0                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVADDSS %XMM0,%XMM4,%XMM4                    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0    | 4       | 0.50\nVMOVSS %XMM3,(%R9)                          | 1     | 0    | 0    | 0.33 | 0.33 | 1  | 0    | 0    | 0.33 | 3       | 1\nVMOVSS %XMM7,(%R11)                         | 1     | 0    | 0    | 0.33 | 0.33 | 1  | 0    | 0    | 0.33 | 3       | 1\nVMOVSS %XMM4,(%R10)                         | 1     | 0    | 0    | 0.33 | 0.33 | 1  | 0    | 0    | 0.33 | 3       | 1\nPOP %RBX                                    | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 2       | 0.50\nPOP %RBP                                    | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0    | 2       | 0.50\nVZEROUPPER                                  | 4     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 1\nRET                                         | 1     | 0    | 0    | 0.33 | 0.33 | 0  | 0    | 1    | 0.33 | 0       | 1\nNOPW (%RAX,%RAX,1)                          | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0    | 0       | 0.25\n",
        },
      },
      header = {
        "Warnings:\n - The number of fused uops of the instruction [VPCMPLTUQ	%YMM8,%YMM9,%K0] is unknown\n - The number of fused uops of the instruction [VPCMPLTUQ	%YMM8,%YMM10,%K1] is unknown\n",
        "10% of peak computational performance is used (6.53 out of 64.00 FLOP per cycle (GFLOPS @ 1GHz))",
      },
      brief = {
      },
      gain = {
        {
          workaround = "Read the \"512-bits vectorization on Skylake SP\" report at \"Potential\" confidence level.",
          details = "70% of SSE/AVX instructions are used in vector version (process two or more data elements in vector registers):\n - 55% of SSE/AVX loads are used in vector version.\n - 0% of SSE/AVX stores are used in vector version.\n - 66% of SSE/AVX addition or subtraction instructions are used in vector version.\n - 64% of SSE/AVX instructions that are not load, store, addition, subtraction nor multiply instructions are used in vector version.\n",
          title = "Vectorization",
          txt = "Your function is partially vectorized.\nOnly 26% of vector register length is used (average across all SSE/AVX instructions).\n",
        },
        {
          workaround = "Reduce the number of FP multiply/FMA instructions",
          title = "Execution units bottlenecks",
          txt = "Performance is limited by execution of FP multiply or FMA (fused multiply-add) operations (the FP multiply/FMA unit is a bottleneck).\n",
        },
      },
      potential = {
        {
          title = "512-bits vectorization on Skylake SP and Icelake Server",
          txt = "On Gold 5122, 6xxx and Platinum Skylake processors and Icelake Server processors, performance can be improved by using 512-bits vectorization if the number of vectorized loops is high and with high trip count.\n",
        },
        {
          workaround = "If your function is irregular, try to remove or hoist conditional structures out of your function. If it mixes elements of different sizes, try to uniformize them.",
          details = "Vector registers are partially exploited, which is expected if your function is irregular or mixes elements of different sizes.",
          title = "Masked instructions",
          txt = "Detected masked instructions.",
        },
        {
          workaround = "Try to change order in which elements are evaluated (using parentheses) in arithmetic expressions containing both ADD/SUB and MUL operations to enable your compiler to generate FMA instructions wherever possible.\nFor instance a + b*c is a valid FMA (MUL then ADD).\nHowever (a+b)* c cannot be translated into an FMA (ADD then MUL).",
          title = "FMA",
          txt = "Detected 64 FMA (fused multiply-add) operations.\nPresence of both ADD/SUB and MUL operations.",
        },
      },
    },
  common = {
    header = {
      "The function is defined in /home/kcamus/qaas_runs/169-401-3406/intel/HACCmk/build/HACCmk/src/Step10_orig.c:10,19-41.\n",
      "Warnings:\nIgnoring paths for analysis",
    },
  },
}
