_cqa_text_report = {
  paths = {
    {
      hint = {
        {
          details = "These instructions generate more than one micro-operation and only one of them can be decoded during a cycle and the extra micro-operations increase pressure on execution units.\n - VCVTSD2SS: 2 occurrences\n - VCVTSS2SD: 4 occurrences\n",
          title = "Complex instructions",
          txt = "Detected COMPLEX INSTRUCTIONS.\n",
        },
        {
          workaround = "Avoid mixing data with different types. In particular, check if the type of constants is the same as array elements. Use double instead of single precision only when/where needed by numerical stability and avoid mixing precision.",
          details = " - VCVTSD2SS (FP64 to FP32, scalar): 2 occurrences\n - VCVTSS2SD (FP32 to FP64, scalar): 4 occurrences\n",
          title = "Conversion instructions",
          txt = "Detected expensive conversion instructions.",
        },
        {
          title = "Type of elements and instruction set",
          txt = "36 SSE or AVX instructions are processing arithmetic or math operations on single precision FP elements in scalar mode (one at a time).\n8 SSE or AVX instructions are processing arithmetic or math operations on double precision FP elements in scalar mode (one at a time).\n",
        },
        {
          title = "Matching between your loop (in the source code) and the binary loop",
          txt = "The binary loop is composed of 60 FP arithmetical operations:\n - 30: addition or subtraction (20 inside FMA instructions)\n - 26: multiply (20 inside FMA instructions)\n - 2: divide\n - 2: square root\nThe binary loop is loading 32 bytes (8 single precision FP elements).",
        },
        {
          title = "Arithmetic intensity",
          txt = "Arithmetic intensity is 1.87 FP operations per loaded or stored byte.",
        },
      },
      expert = {
        {
          title = "General properties",
          txt = "nb instructions    : 70\nnb uops            : 75\nloop length        : 370\nused x86 registers : 6\nused mmx registers : 0\nused xmm registers : 32\nused ymm registers : 0\nused zmm registers : 0\nnb stack references: 0\nADD-SUB / MUL ratio: 1.67\n",
        },
        {
          title = "Front-end",
          txt = "ASSUMED MACRO FUSION\nFIT IN UOP CACHE\nmicro-operation queue: 18.75 cycles\nfront end            : 18.75 cycles\n",
        },
        {
          title = "Back-end",
          txt = "       | P0    | P1    | P2   | P3   | P4   | P5   | P6   | P7\n----------------------------------------------------------------\nuops   | 25.00 | 25.00 | 4.00 | 4.00 | 0.00 | 6.50 | 6.50 | 0.00\ncycles | 25.00 | 25.00 | 4.00 | 4.00 | 0.00 | 6.50 | 6.50 | 0.00\n\nCycles executing div or sqrt instructions: 17.00-20.00\n",
        },
        {
          title = "Front-end and detailed OoO resources (UFS)",
          txt = "FE+BE cycles           : 32.13-33.75\nStall cycles           : 12.86-14.47\nRS full (events)       : 0.57-0.31\nPRF_FLOAT full (events): 17.82-20.08\n",
        },
        {
          title = "Cycles summary",
          txt = "Front-end : 18.75\nDispatch  : 25.00\nDIV/SQRT  : 17.00-20.00\nOverall L1: 25.00\n",
        },
        {
          title = "Vectorization ratios",
          txt = "all     : 6%\nload    : 0%\nstore   : NA (no store vectorizable/vectorized instructions)\nmul     : 0%\nadd-sub : 0%\nfma     : 0%\ndiv/sqrt: 0%\nother   : 28%\n",
        },
        {
          title = "Vector efficiency ratios",
          txt = "all     : 8%\nload    : 6%\nstore   : NA (no store vectorizable/vectorized instructions)\nmul     : 8%\nadd-sub : 7%\nfma     : 6%\ndiv/sqrt: 12%\nother   : 12%\n",
        },
        {
          title = "Cycles and memory resources usage",
          txt = "Assuming all data fit into the L1 cache, each iteration of the binary loop takes 25.00 cycles. At this rate:\n - 1% of peak load performance is reached (1.28 out of 128.00 bytes loaded per cycle (GB/s @ 1GHz))\n",
        },
        {
          title = "Front-end bottlenecks",
          txt = "Found no such bottlenecks.",
        },
        {
          title = "ASM code",
          txt = "In the binary file, the address of the loop is: 401fd5\n\nInstruction                     | Nb FU | P0   | P1   | P2   | P3   | P4 | P5   | P6   | P7 | Latency | Recip. throughput\n-------------------------------------------------------------------------------------------------------------------------\nVMOVSS (%RDX,%RDI,4),%XMM31     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 4-5     | 0.50\nVMOVSS (%RSI,%RDI,4),%XMM18     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 4-5     | 0.50\nVXORPS %XMM24,%XMM24,%XMM24     | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 0       | 0.25\nVMOVSS (%RCX,%RDI,4),%XMM26     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 4-5     | 0.50\nVSUBSS %XMM1,%XMM31,%XMM28      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVSUBSS %XMM7,%XMM18,%XMM29      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVSUBSS %XMM2,%XMM26,%XMM25      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVMULSS %XMM28,%XMM28,%XMM0      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231SS %XMM29,%XMM29,%XMM0 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231SS %XMM25,%XMM25,%XMM0 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCOMISS %XMM0,%XMM3             | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 3       | 1\nJBE 401f6c <Step10_orig+0x58c>  | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0  | 0       | 0.50-1\nVMOVSS (%R8,%RDI,4),%XMM24      | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 4-5     | 0.50\nVCOMISS %XMM6,%XMM0             | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 3       | 1\nJBE 401fd2 <Step10_orig+0x5f2>  | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0  | 0       | 0.50-1\nVMOVAPS %XMM0,%XMM23            | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 0       | 0.25\nVADDSS %XMM0,%XMM4,%XMM5        | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD132SS %XMM8,%XMM9,%XMM23  | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTSS2SD %XMM5,%XMM5,%XMM5     | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 5       | 1\nVFMADD132SS %XMM0,%XMM10,%XMM23 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD132SS %XMM0,%XMM11,%XMM23 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD132SS %XMM0,%XMM12,%XMM23 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD132SS %XMM0,%XMM13,%XMM23 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVSQRTSD %XMM5,%XMM5,%XMM0       | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-19   | 4.50-6\nVMULSD %XMM0,%XMM5,%XMM5        | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTSS2SD %XMM23,%XMM23,%XMM20  | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 5       | 1\nVDIVSD %XMM5,%XMM14,%XMM0       | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-14   | 4\nVADDSD %XMM20,%XMM0,%XMM5       | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTSD2SS %XMM5,%XMM5,%XMM0     | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 5       | 1\nVMULSS %XMM24,%XMM0,%XMM5       | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231SS %XMM5,%XMM29,%XMM15 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231SS %XMM5,%XMM28,%XMM16 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231SS %XMM5,%XMM25,%XMM17 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nINC %RDI                        | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0  | 1       | 0.25\nVMOVSS (%RDX,%RDI,4),%XMM23     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 4-5     | 0.50\nVMOVSS (%RSI,%RDI,4),%XMM25     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 4-5     | 0.50\nVXORPS %XMM19,%XMM19,%XMM19     | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 0       | 0.25\nVMOVSS (%RCX,%RDI,4),%XMM22     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 4-5     | 0.50\nVSUBSS %XMM1,%XMM23,%XMM20      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVSUBSS %XMM7,%XMM25,%XMM24      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVSUBSS %XMM2,%XMM22,%XMM30      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVMULSS %XMM20,%XMM20,%XMM0      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231SS %XMM24,%XMM24,%XMM0 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231SS %XMM30,%XMM30,%XMM0 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCOMISS %XMM0,%XMM3             | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 3       | 1\nJBE 402021 <Step10_orig+0x641>  | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0  | 0       | 0.50-1\nVMOVSS (%R8,%RDI,4),%XMM19      | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 4-5     | 0.50\nVCOMISS %XMM6,%XMM0             | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 3       | 1\nJBE 402087 <Step10_orig+0x6a7>  | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0  | 0       | 0.50-1\nVADDSS %XMM0,%XMM4,%XMM5        | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVMOVAPS %XMM0,%XMM21            | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 0       | 0.25\nVFMADD132SS %XMM8,%XMM9,%XMM21  | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTSS2SD %XMM5,%XMM5,%XMM5     | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 5       | 1\nVSQRTSD %XMM5,%XMM5,%XMM27      | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-19   | 4.50-6\nVMULSD %XMM27,%XMM5,%XMM5       | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD132SS %XMM0,%XMM10,%XMM21 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVDIVSD %XMM5,%XMM14,%XMM5       | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-14   | 4\nVFMADD132SS %XMM0,%XMM11,%XMM21 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD132SS %XMM0,%XMM12,%XMM21 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD132SS %XMM21,%XMM13,%XMM0 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTSS2SD %XMM0,%XMM0,%XMM0     | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 5       | 1\nVADDSD %XMM0,%XMM5,%XMM5        | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTSD2SS %XMM5,%XMM5,%XMM0     | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 5       | 1\nVMULSS %XMM19,%XMM0,%XMM5       | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231SS %XMM5,%XMM24,%XMM15 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231SS %XMM5,%XMM20,%XMM16 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231SS %XMM5,%XMM30,%XMM17 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nINC %RDI                        | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0  | 1       | 0.25\nCMP %EDI,%EAX                   | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0  | 1       | 0.25\nJG 401f20 <Step10_orig+0x540>   | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0  | 0       | 0.50-1\n",
        },
      },
      header = {
        "3% of peak computational performance is used (2.40 out of 64.00 FLOP per cycle (GFLOPS @ 1GHz))",
      },
      brief = {
      },
      gain = {
        {
          workaround = " - Try another compiler or update/tune your current one\n - Remove inter-iterations dependences from your loop and make it unit-stride:\n  * If your arrays have 2 or more dimensions, check whether elements are accessed contiguously and, otherwise, try to permute loops accordingly\n  * If your loop streams arrays of structures (AoS), try to use structures of arrays instead (SoA)\n",
          details = "Store and arithmetical SSE/AVX instructions are used in scalar version (process only one data element in vector registers).\nSince your execution units are vector units, only a vectorized loop can use their full power.\n",
          title = "Vectorization",
          txt = "Your loop is probably not vectorized.\nOnly 8% of vector register length is used (average across all SSE/AVX instructions).\nBy vectorizing your loop, you can lower the cost of an iteration from 25.00 to 10.00 cycles (2.50x speedup).",
        },
        {
          workaround = "Reduce the number of FP multiply/FMA instructions",
          title = "Execution units bottlenecks",
          txt = "Performance is limited by execution of FP multiply or FMA (fused multiply-add) operations (the FP multiply/FMA unit is a bottleneck).\n",
        },
      },
      potential = {
        {
          workaround = "Try to change order in which elements are evaluated (using parentheses) in arithmetic expressions containing both ADD/SUB and MUL operations to enable your compiler to generate FMA instructions wherever possible.\nFor instance a + b*c is a valid FMA (MUL then ADD).\nHowever (a+b)* c cannot be translated into an FMA (ADD then MUL).",
          title = "FMA",
          txt = "Detected 20 FMA (fused multiply-add) operations.\nPresence of both ADD/SUB and MUL operations.",
        },
      },
    },
  },
  AVG = {
      hint = {
        {
          details = "These instructions generate more than one micro-operation and only one of them can be decoded during a cycle and the extra micro-operations increase pressure on execution units.\n - VCVTSD2SS: 2 occurrences\n - VCVTSS2SD: 4 occurrences\n",
          title = "Complex instructions",
          txt = "Detected COMPLEX INSTRUCTIONS.\n",
        },
        {
          workaround = "Avoid mixing data with different types. In particular, check if the type of constants is the same as array elements. Use double instead of single precision only when/where needed by numerical stability and avoid mixing precision.",
          details = " - VCVTSD2SS (FP64 to FP32, scalar): 2 occurrences\n - VCVTSS2SD (FP32 to FP64, scalar): 4 occurrences\n",
          title = "Conversion instructions",
          txt = "Detected expensive conversion instructions.",
        },
        {
          title = "Type of elements and instruction set",
          txt = "36 SSE or AVX instructions are processing arithmetic or math operations on single precision FP elements in scalar mode (one at a time).\n8 SSE or AVX instructions are processing arithmetic or math operations on double precision FP elements in scalar mode (one at a time).\n",
        },
        {
          title = "Matching between your loop (in the source code) and the binary loop",
          txt = "The binary loop is composed of 60 FP arithmetical operations:\n - 30: addition or subtraction (20 inside FMA instructions)\n - 26: multiply (20 inside FMA instructions)\n - 2: divide\n - 2: square root\nThe binary loop is loading 32 bytes (8 single precision FP elements).",
        },
        {
          title = "Arithmetic intensity",
          txt = "Arithmetic intensity is 1.87 FP operations per loaded or stored byte.",
        },
      },
      expert = {
        {
          title = "General properties",
          txt = "nb instructions    : 70\nnb uops            : 75\nloop length        : 370\nused x86 registers : 6\nused mmx registers : 0\nused xmm registers : 32\nused ymm registers : 0\nused zmm registers : 0\nnb stack references: 0\nADD-SUB / MUL ratio: 1.67\n",
        },
        {
          title = "Front-end",
          txt = "ASSUMED MACRO FUSION\nFIT IN UOP CACHE\nmicro-operation queue: 18.75 cycles\nfront end            : 18.75 cycles\n",
        },
        {
          title = "Back-end",
          txt = "       | P0    | P1    | P2   | P3   | P4   | P5   | P6   | P7\n----------------------------------------------------------------\nuops   | 25.00 | 25.00 | 4.00 | 4.00 | 0.00 | 6.50 | 6.50 | 0.00\ncycles | 25.00 | 25.00 | 4.00 | 4.00 | 0.00 | 6.50 | 6.50 | 0.00\n\nCycles executing div or sqrt instructions: 17.00-20.00\n",
        },
        {
          title = "Front-end and detailed OoO resources (UFS)",
          txt = "FE+BE cycles           : 32.13-33.75\nStall cycles           : 12.86-14.47\nRS full (events)       : 0.57-0.31\nPRF_FLOAT full (events): 17.82-20.08\n",
        },
        {
          title = "Cycles summary",
          txt = "Front-end : 18.75\nDispatch  : 25.00\nDIV/SQRT  : 17.00-20.00\nOverall L1: 25.00\n",
        },
        {
          title = "Vectorization ratios",
          txt = "all     : 6%\nload    : 0%\nstore   : NA (no store vectorizable/vectorized instructions)\nmul     : 0%\nadd-sub : 0%\nfma     : 0%\ndiv/sqrt: 0%\nother   : 28%\n",
        },
        {
          title = "Vector efficiency ratios",
          txt = "all     : 8%\nload    : 6%\nstore   : NA (no store vectorizable/vectorized instructions)\nmul     : 8%\nadd-sub : 7%\nfma     : 6%\ndiv/sqrt: 12%\nother   : 12%\n",
        },
        {
          title = "Cycles and memory resources usage",
          txt = "Assuming all data fit into the L1 cache, each iteration of the binary loop takes 25.00 cycles. At this rate:\n - 1% of peak load performance is reached (1.28 out of 128.00 bytes loaded per cycle (GB/s @ 1GHz))\n",
        },
        {
          title = "Front-end bottlenecks",
          txt = "Found no such bottlenecks.",
        },
        {
          title = "ASM code",
          txt = "In the binary file, the address of the loop is: 401fd5\n\nInstruction                     | Nb FU | P0   | P1   | P2   | P3   | P4 | P5   | P6   | P7 | Latency | Recip. throughput\n-------------------------------------------------------------------------------------------------------------------------\nVMOVSS (%RDX,%RDI,4),%XMM31     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 4-5     | 0.50\nVMOVSS (%RSI,%RDI,4),%XMM18     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 4-5     | 0.50\nVXORPS %XMM24,%XMM24,%XMM24     | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 0       | 0.25\nVMOVSS (%RCX,%RDI,4),%XMM26     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 4-5     | 0.50\nVSUBSS %XMM1,%XMM31,%XMM28      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVSUBSS %XMM7,%XMM18,%XMM29      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVSUBSS %XMM2,%XMM26,%XMM25      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVMULSS %XMM28,%XMM28,%XMM0      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231SS %XMM29,%XMM29,%XMM0 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231SS %XMM25,%XMM25,%XMM0 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCOMISS %XMM0,%XMM3             | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 3       | 1\nJBE 401f6c <Step10_orig+0x58c>  | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0  | 0       | 0.50-1\nVMOVSS (%R8,%RDI,4),%XMM24      | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 4-5     | 0.50\nVCOMISS %XMM6,%XMM0             | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 3       | 1\nJBE 401fd2 <Step10_orig+0x5f2>  | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0  | 0       | 0.50-1\nVMOVAPS %XMM0,%XMM23            | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 0       | 0.25\nVADDSS %XMM0,%XMM4,%XMM5        | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD132SS %XMM8,%XMM9,%XMM23  | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTSS2SD %XMM5,%XMM5,%XMM5     | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 5       | 1\nVFMADD132SS %XMM0,%XMM10,%XMM23 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD132SS %XMM0,%XMM11,%XMM23 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD132SS %XMM0,%XMM12,%XMM23 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD132SS %XMM0,%XMM13,%XMM23 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVSQRTSD %XMM5,%XMM5,%XMM0       | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-19   | 4.50-6\nVMULSD %XMM0,%XMM5,%XMM5        | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTSS2SD %XMM23,%XMM23,%XMM20  | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 5       | 1\nVDIVSD %XMM5,%XMM14,%XMM0       | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-14   | 4\nVADDSD %XMM20,%XMM0,%XMM5       | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTSD2SS %XMM5,%XMM5,%XMM0     | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 5       | 1\nVMULSS %XMM24,%XMM0,%XMM5       | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231SS %XMM5,%XMM29,%XMM15 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231SS %XMM5,%XMM28,%XMM16 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231SS %XMM5,%XMM25,%XMM17 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nINC %RDI                        | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0  | 1       | 0.25\nVMOVSS (%RDX,%RDI,4),%XMM23     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 4-5     | 0.50\nVMOVSS (%RSI,%RDI,4),%XMM25     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 4-5     | 0.50\nVXORPS %XMM19,%XMM19,%XMM19     | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 0       | 0.25\nVMOVSS (%RCX,%RDI,4),%XMM22     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 4-5     | 0.50\nVSUBSS %XMM1,%XMM23,%XMM20      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVSUBSS %XMM7,%XMM25,%XMM24      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVSUBSS %XMM2,%XMM22,%XMM30      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVMULSS %XMM20,%XMM20,%XMM0      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231SS %XMM24,%XMM24,%XMM0 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231SS %XMM30,%XMM30,%XMM0 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCOMISS %XMM0,%XMM3             | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 3       | 1\nJBE 402021 <Step10_orig+0x641>  | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0  | 0       | 0.50-1\nVMOVSS (%R8,%RDI,4),%XMM19      | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 4-5     | 0.50\nVCOMISS %XMM6,%XMM0             | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 3       | 1\nJBE 402087 <Step10_orig+0x6a7>  | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0  | 0       | 0.50-1\nVADDSS %XMM0,%XMM4,%XMM5        | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVMOVAPS %XMM0,%XMM21            | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 0       | 0.25\nVFMADD132SS %XMM8,%XMM9,%XMM21  | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTSS2SD %XMM5,%XMM5,%XMM5     | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 5       | 1\nVSQRTSD %XMM5,%XMM5,%XMM27      | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-19   | 4.50-6\nVMULSD %XMM27,%XMM5,%XMM5       | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD132SS %XMM0,%XMM10,%XMM21 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVDIVSD %XMM5,%XMM14,%XMM5       | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-14   | 4\nVFMADD132SS %XMM0,%XMM11,%XMM21 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD132SS %XMM0,%XMM12,%XMM21 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD132SS %XMM21,%XMM13,%XMM0 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTSS2SD %XMM0,%XMM0,%XMM0     | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 5       | 1\nVADDSD %XMM0,%XMM5,%XMM5        | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTSD2SS %XMM5,%XMM5,%XMM0     | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 5       | 1\nVMULSS %XMM19,%XMM0,%XMM5       | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231SS %XMM5,%XMM24,%XMM15 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231SS %XMM5,%XMM20,%XMM16 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231SS %XMM5,%XMM30,%XMM17 | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nINC %RDI                        | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0  | 1       | 0.25\nCMP %EDI,%EAX                   | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0  | 1       | 0.25\nJG 401f20 <Step10_orig+0x540>   | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0  | 0       | 0.50-1\n",
        },
      },
      header = {
        "3% of peak computational performance is used (2.40 out of 64.00 FLOP per cycle (GFLOPS @ 1GHz))",
      },
      brief = {
      },
      gain = {
        {
          workaround = " - Try another compiler or update/tune your current one\n - Remove inter-iterations dependences from your loop and make it unit-stride:\n  * If your arrays have 2 or more dimensions, check whether elements are accessed contiguously and, otherwise, try to permute loops accordingly\n  * If your loop streams arrays of structures (AoS), try to use structures of arrays instead (SoA)\n",
          details = "Store and arithmetical SSE/AVX instructions are used in scalar version (process only one data element in vector registers).\nSince your execution units are vector units, only a vectorized loop can use their full power.\n",
          title = "Vectorization",
          txt = "Your loop is probably not vectorized.\nOnly 8% of vector register length is used (average across all SSE/AVX instructions).\nBy vectorizing your loop, you can lower the cost of an iteration from 25.00 to 10.00 cycles (2.50x speedup).",
        },
        {
          workaround = "Reduce the number of FP multiply/FMA instructions",
          title = "Execution units bottlenecks",
          txt = "Performance is limited by execution of FP multiply or FMA (fused multiply-add) operations (the FP multiply/FMA unit is a bottleneck).\n",
        },
      },
      potential = {
        {
          workaround = "Try to change order in which elements are evaluated (using parentheses) in arithmetic expressions containing both ADD/SUB and MUL operations to enable your compiler to generate FMA instructions wherever possible.\nFor instance a + b*c is a valid FMA (MUL then ADD).\nHowever (a+b)* c cannot be translated into an FMA (ADD then MUL).",
          title = "FMA",
          txt = "Detected 20 FMA (fused multiply-add) operations.\nPresence of both ADD/SUB and MUL operations.",
        },
      },
    },
  common = {
    header = {
      "The loop is defined in /home/kcamus/qaas_runs/169-401-3406/intel/HACCmk/build/HACCmk/src/Step10_orig.c:19-35.\n",
      "The related source loop is not unrolled or unrolled with no peel/tail loop.",
      "Warnings:\n - Ignoring paths for analysis\n - Failed to get the number of paths\n - RecMII not computed since number of paths is unknown or > max_paths\n - Streams not analyzed since number of paths is unknown or > max_paths\n",
    },
  },
}
