_cqa_text_report = {
  paths = {
    {
      hint = {
        {
          details = "These instructions generate more than one micro-operation and only one of them can be decoded during a cycle and the extra micro-operations increase pressure on execution units.\n - VCVTPD2PS: 2 occurrences\n - VCVTPS2PD: 4 occurrences\n - VDIVPD: 2 occurrences\n - VSQRTPD: 2 occurrences\n",
          title = "Complex instructions",
          txt = "Detected COMPLEX INSTRUCTIONS.\n",
        },
        {
          workaround = "Use vector aligned instructions:\n 1) align your arrays on 64 bytes boundaries\n 2) inform your compiler that your arrays are vector aligned: if array 'foo' is 64 bytes-aligned, define a pointer 'p_foo' as __builtin_assume_aligned (foo, 64) and use it instead of 'foo' in the loop.\n",
          details = " - VEXTRACTF32X8: 2 occurrences\n - VINSERTF64X4: 1 occurrences\n",
          title = "Vector unaligned load/store instructions",
          txt = "Detected 3 suboptimal vector unaligned load/store instructions.\n",
        },
        {
          workaround = "Avoid mixing data with different types. In particular, check if the type of constants is the same as array elements. Use double instead of single precision only when/where needed by numerical stability and avoid mixing precision.",
          details = " - VCVTPD2PS (FP64 to FP32, SIMD): 2 occurrences\n - VCVTPS2PD (FP32 to FP64, SIMD): 4 occurrences\n",
          title = "Conversion instructions",
          txt = "Detected expensive conversion instructions.",
        },
        {
          title = "Type of elements and instruction set",
          txt = "21 AVX-512 instructions are processing arithmetic or math operations on single precision FP elements in vector mode (sixteen at a time).\n8 AVX-512 instructions are processing arithmetic or math operations on double precision FP elements in vector mode (eight at a time).\n",
        },
        {
          title = "Matching between your loop (in the source code) and the binary loop",
          txt = "The binary loop is composed of 480 FP arithmetical operations:\n - 240: addition or subtraction (112 inside FMA instructions)\n - 208: multiply (112 inside FMA instructions)\n - 16: divide\n - 16: square root\nThe binary loop is loading 256 bytes (64 single precision FP elements).",
        },
        {
          title = "Arithmetic intensity",
          txt = "Arithmetic intensity is 1.87 FP operations per loaded or stored byte.",
        },
      },
      expert = {
        {
          title = "General properties",
          txt = "nb instructions    : 47\nnb uops            : 60\nloop length        : 286\nused x86 registers : 6\nused mmx registers : 0\nused xmm registers : 0\nused ymm registers : 3\nused zmm registers : 27\nnb stack references: 0\nADD-SUB / MUL ratio: 1.29\n",
        },
        {
          title = "Front-end",
          txt = "ASSUMED MACRO FUSION\nFIT IN UOP CACHE\nmicro-operation queue: 15.00 cycles\nfront end            : 15.00 cycles\n",
        },
        {
          title = "Back-end",
          txt = "       | P0    | P1    | P2   | P3   | P4   | P5    | P6   | P7\n-----------------------------------------------------------------\nuops   | 26.00 | 1.00  | 2.00 | 2.00 | 0.00 | 26.00 | 1.00 | 0.00\ncycles | 26.00 | 11.50 | 2.00 | 2.00 | 0.00 | 26.00 | 1.00 | 0.00\n\nCycles executing div or sqrt instructions: 68.00-80.00\nLongest recurrence chain latency (RecMII): 4.00\n",
        },
        {
          title = "Front-end and detailed OoO resources (UFS)",
          txt = "FE+BE cycles           : 69.77-84.37\nStall cycles           : 54.31-68.91\nRS full (events)       : 7.29-12.61\nPRF_FLOAT full (events): 56.06-66.55\n",
        },
        {
          title = "Cycles summary",
          txt = "Front-end : 15.00\nDispatch  : 26.00\nDIV/SQRT  : 68.00-80.00\nData deps.: 4.00\nOverall L1: 68.00-80.00\n",
        },
        {
          title = "Vectorization ratios",
          txt = "all     : 100%\nload    : 100%\nstore   : NA (no store vectorizable/vectorized instructions)\nmul     : 100%\nadd-sub : 100%\nfma     : 100%\ndiv/sqrt: 100%\nother   : 100%\n",
        },
        {
          title = "Vector efficiency ratios",
          txt = "all     : 92%\nload    : 100%\nstore   : NA (no store vectorizable/vectorized instructions)\nmul     : 100%\nadd-sub : 100%\nfma     : 100%\ndiv/sqrt: 100%\nother   : 73%\n",
        },
        {
          title = "Cycles and memory resources usage",
          txt = "Detected masked instructions: assuming all mask elements are active.\nAssuming all data fit into the L1 cache, each iteration of the binary loop takes 80.00 cycles. At this rate:\n - 2% of peak load performance is reached (3.20 out of 128.00 bytes loaded per cycle (GB/s @ 1GHz))\n",
        },
        {
          title = "Front-end bottlenecks",
          txt = "Found no such bottlenecks.",
        },
        {
          title = "ASM code",
          txt = "In the binary file, the address of the loop is: 401a90\n\nInstruction                         | Nb FU | P0   | P1   | P2   | P3   | P4 | P5   | P6   | P7 | Latency | Recip. throughput\n-----------------------------------------------------------------------------------------------------------------------------\nVMOVUPS (%RDX,%R11,1),%ZMM0         | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nVMOVUPS (%RSI,%R11,1),%ZMM6         | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nVMOVUPS (%RCX,%R11,1),%ZMM5         | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nVSUBPS %ZMM25,%ZMM0,%ZMM8           | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVSUBPS %ZMM26,%ZMM6,%ZMM9           | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVSUBPS %ZMM24,%ZMM5,%ZMM30          | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVMULPS %ZMM8,%ZMM8,%ZMM28           | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVFMADD231PS %ZMM9,%ZMM9,%ZMM28      | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVFMADD231PS %ZMM30,%ZMM30,%ZMM28    | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVCMPPS $0xe,%ZMM15,%ZMM28,%K2       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 4       | 1\nVCMPPS $0x1,%ZMM23,%ZMM28,%K1       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 4       | 1\nVADDPS %ZMM22,%ZMM28,%ZMM0          | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVCVTPS2PD %YMM0,%ZMM6               | 2     | 0.50 | 0    | 0    | 0    | 0  | 1.50 | 0    | 0  | 7       | 1\nVEXTRACTF32X8 $0x1,%ZMM0,%YMM5      | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVMOVAPS %ZMM28,%ZMM0                | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 0       | 0.25\nVSQRTPD %ZMM6,%ZMM29                | 3     | 2    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 24-33   | 18-24\nVCVTPS2PD %YMM5,%ZMM5               | 2     | 0.50 | 0    | 0    | 0    | 0  | 1.50 | 0    | 0  | 7       | 1\nVMULPD %ZMM29,%ZMM6,%ZMM6           | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVFMADD132PS %ZMM21,%ZMM20,%ZMM0     | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVSQRTPD %ZMM5,%ZMM31                | 3     | 2    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 24-33   | 18-24\nVMULPD %ZMM31,%ZMM5,%ZMM5           | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVMOVUPS (%R8,%R11,1),%ZMM13{%K1}    | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nADD $0x40,%R11                      | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0  | 1       | 0.25\nVMOVAPS %ZMM13,%ZMM27{%K1}{z}       | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 0       | 0.25\nVFMADD132PS %ZMM28,%ZMM19,%ZMM0     | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVDIVPD %ZMM6,%ZMM14,%ZMM6           | 3     | 2.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 24      | 16\nVDIVPD %ZMM5,%ZMM14,%ZMM5           | 3     | 2.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 24      | 16\nVFMADD132PS %ZMM28,%ZMM18,%ZMM0     | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVFMADD132PS %ZMM28,%ZMM17,%ZMM0     | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVFMADD132PS %ZMM28,%ZMM16,%ZMM0     | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVCVTPS2PD %YMM0,%ZMM28              | 2     | 0.50 | 0    | 0    | 0    | 0  | 1.50 | 0    | 0  | 7       | 1\nVEXTRACTF32X8 $0x1,%ZMM0,%YMM0      | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVADDPD %ZMM28,%ZMM6,%ZMM6           | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVCVTPS2PD %YMM0,%ZMM0               | 2     | 0.50 | 0    | 0    | 0    | 0  | 1.50 | 0    | 0  | 7       | 1\nVADDPD %ZMM0,%ZMM5,%ZMM5            | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVCVTPD2PS %ZMM6,%YMM6               | 2     | 0.50 | 0    | 0    | 0    | 0  | 1.50 | 0    | 0  | 7       | 1\nVCVTPD2PS %ZMM5,%YMM0               | 2     | 0.50 | 0    | 0    | 0    | 0  | 1.50 | 0    | 0  | 7       | 1\nVINSERTF64X4 $0x1,%YMM0,%ZMM6,%ZMM5 | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVMULPS %ZMM27,%ZMM5,%ZMM6           | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVMULPS %ZMM6,%ZMM9,%ZMM0{%K2}{z}    | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVMULPS %ZMM6,%ZMM8,%ZMM9{%K2}{z}    | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVMULPS %ZMM6,%ZMM30,%ZMM8{%K2}{z}   | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVADDPS %ZMM0,%ZMM10,%ZMM10          | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVADDPS %ZMM9,%ZMM11,%ZMM11          | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVADDPS %ZMM8,%ZMM12,%ZMM12          | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nCMP %R11,%RBX                       | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0  | 1       | 0.25\nJNE 401a90 <Step10_orig+0xb0>       | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0  | 0       | 0.50-1\n",
        },
      },
      header = {
        "9% of peak computational performance is used (6.00 out of 64.00 FLOP per cycle (GFLOPS @ 1GHz))",
      },
      brief = {
      },
      gain = {
        {
          details = "All SSE/AVX instructions are used in vector version (process two or more data elements in vector registers).\n",
          title = "Vectorization",
          txt = "Your loop is vectorized, but using 92% register length (average across all SSE/AVX instructions).\n",
        },
        {
          workaround = " - Reduce the number of division or square root instructions:\n  * If denominator is constant over iterations, use reciprocal (replace x/y with x*(1/y)). Check precision impact. This will be done by your compiler with ffast-math or Ofast\n - If you accept to loose numerical precision up to 2 ulp, you can speedup your code by passing the following options to your compiler: (ffast-math or Ofast) and mrecip\n",
          title = "Execution units bottlenecks",
          txt = "Performance is limited by execution of divide and square root operations (the divide/square root unit is a bottleneck).\n\nBy removing all these bottlenecks, you can lower the cost of an iteration from 80.00 to 26.00 cycles (3.08x speedup).\n",
        },
      },
      potential = {
        {
          title = "Expensive FP math instructions/calls",
          txt = "Detected performance impact from expensive FP math instructions/calls.\nBy removing/reexpressing them, you can lower the cost of an iteration from 80.00 to 20.00 cycles (4.00x speedup).",
        },
        {
          workaround = "If your loop is irregular, try to remove or hoist conditional structures out of your loop. If it mixes elements of different sizes, try to uniformize them.",
          details = "Vector registers are partially exploited, which is expected if your loop is irregular or mixes elements of different sizes.",
          title = "Masked instructions",
          txt = "Detected masked instructions.",
        },
        {
          workaround = "Try to change order in which elements are evaluated (using parentheses) in arithmetic expressions containing both ADD/SUB and MUL operations to enable your compiler to generate FMA instructions wherever possible.\nFor instance a + b*c is a valid FMA (MUL then ADD).\nHowever (a+b)* c cannot be translated into an FMA (ADD then MUL).",
          title = "FMA",
          txt = "Detected 112 FMA (fused multiply-add) operations.\nPresence of both ADD/SUB and MUL operations.",
        },
      },
    },
  },
  AVG = {
      hint = {
        {
          details = "These instructions generate more than one micro-operation and only one of them can be decoded during a cycle and the extra micro-operations increase pressure on execution units.\n - VCVTPD2PS: 2 occurrences\n - VCVTPS2PD: 4 occurrences\n - VDIVPD: 2 occurrences\n - VSQRTPD: 2 occurrences\n",
          title = "Complex instructions",
          txt = "Detected COMPLEX INSTRUCTIONS.\n",
        },
        {
          workaround = "Use vector aligned instructions:\n 1) align your arrays on 64 bytes boundaries\n 2) inform your compiler that your arrays are vector aligned: if array 'foo' is 64 bytes-aligned, define a pointer 'p_foo' as __builtin_assume_aligned (foo, 64) and use it instead of 'foo' in the loop.\n",
          details = " - VEXTRACTF32X8: 2 occurrences\n - VINSERTF64X4: 1 occurrences\n",
          title = "Vector unaligned load/store instructions",
          txt = "Detected 3 suboptimal vector unaligned load/store instructions.\n",
        },
        {
          workaround = "Avoid mixing data with different types. In particular, check if the type of constants is the same as array elements. Use double instead of single precision only when/where needed by numerical stability and avoid mixing precision.",
          details = " - VCVTPD2PS (FP64 to FP32, SIMD): 2 occurrences\n - VCVTPS2PD (FP32 to FP64, SIMD): 4 occurrences\n",
          title = "Conversion instructions",
          txt = "Detected expensive conversion instructions.",
        },
        {
          title = "Type of elements and instruction set",
          txt = "21 AVX-512 instructions are processing arithmetic or math operations on single precision FP elements in vector mode (sixteen at a time).\n8 AVX-512 instructions are processing arithmetic or math operations on double precision FP elements in vector mode (eight at a time).\n",
        },
        {
          title = "Matching between your loop (in the source code) and the binary loop",
          txt = "The binary loop is composed of 480 FP arithmetical operations:\n - 240: addition or subtraction (112 inside FMA instructions)\n - 208: multiply (112 inside FMA instructions)\n - 16: divide\n - 16: square root\nThe binary loop is loading 256 bytes (64 single precision FP elements).",
        },
        {
          title = "Arithmetic intensity",
          txt = "Arithmetic intensity is 1.87 FP operations per loaded or stored byte.",
        },
      },
      expert = {
        {
          title = "General properties",
          txt = "nb instructions    : 47\nnb uops            : 60\nloop length        : 286\nused x86 registers : 6\nused mmx registers : 0\nused xmm registers : 0\nused ymm registers : 3\nused zmm registers : 27\nnb stack references: 0\nADD-SUB / MUL ratio: 1.29\n",
        },
        {
          title = "Front-end",
          txt = "ASSUMED MACRO FUSION\nFIT IN UOP CACHE\nmicro-operation queue: 15.00 cycles\nfront end            : 15.00 cycles\n",
        },
        {
          title = "Back-end",
          txt = "       | P0    | P1    | P2   | P3   | P4   | P5    | P6   | P7\n-----------------------------------------------------------------\nuops   | 26.00 | 1.00  | 2.00 | 2.00 | 0.00 | 26.00 | 1.00 | 0.00\ncycles | 26.00 | 11.50 | 2.00 | 2.00 | 0.00 | 26.00 | 1.00 | 0.00\n\nCycles executing div or sqrt instructions: 68.00-80.00\nLongest recurrence chain latency (RecMII): 4.00\n",
        },
        {
          title = "Front-end and detailed OoO resources (UFS)",
          txt = "FE+BE cycles           : 69.77-84.37\nStall cycles           : 54.31-68.91\nRS full (events)       : 7.29-12.61\nPRF_FLOAT full (events): 56.06-66.55\n",
        },
        {
          title = "Cycles summary",
          txt = "Front-end : 15.00\nDispatch  : 26.00\nDIV/SQRT  : 68.00-80.00\nData deps.: 4.00\nOverall L1: 68.00-80.00\n",
        },
        {
          title = "Vectorization ratios",
          txt = "all     : 100%\nload    : 100%\nstore   : NA (no store vectorizable/vectorized instructions)\nmul     : 100%\nadd-sub : 100%\nfma     : 100%\ndiv/sqrt: 100%\nother   : 100%\n",
        },
        {
          title = "Vector efficiency ratios",
          txt = "all     : 92%\nload    : 100%\nstore   : NA (no store vectorizable/vectorized instructions)\nmul     : 100%\nadd-sub : 100%\nfma     : 100%\ndiv/sqrt: 100%\nother   : 73%\n",
        },
        {
          title = "Cycles and memory resources usage",
          txt = "Detected masked instructions: assuming all mask elements are active.\nAssuming all data fit into the L1 cache, each iteration of the binary loop takes 80.00 cycles. At this rate:\n - 2% of peak load performance is reached (3.20 out of 128.00 bytes loaded per cycle (GB/s @ 1GHz))\n",
        },
        {
          title = "Front-end bottlenecks",
          txt = "Found no such bottlenecks.",
        },
        {
          title = "ASM code",
          txt = "In the binary file, the address of the loop is: 401a90\n\nInstruction                         | Nb FU | P0   | P1   | P2   | P3   | P4 | P5   | P6   | P7 | Latency | Recip. throughput\n-----------------------------------------------------------------------------------------------------------------------------\nVMOVUPS (%RDX,%R11,1),%ZMM0         | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nVMOVUPS (%RSI,%R11,1),%ZMM6         | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nVMOVUPS (%RCX,%R11,1),%ZMM5         | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nVSUBPS %ZMM25,%ZMM0,%ZMM8           | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVSUBPS %ZMM26,%ZMM6,%ZMM9           | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVSUBPS %ZMM24,%ZMM5,%ZMM30          | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVMULPS %ZMM8,%ZMM8,%ZMM28           | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVFMADD231PS %ZMM9,%ZMM9,%ZMM28      | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVFMADD231PS %ZMM30,%ZMM30,%ZMM28    | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVCMPPS $0xe,%ZMM15,%ZMM28,%K2       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 4       | 1\nVCMPPS $0x1,%ZMM23,%ZMM28,%K1       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 4       | 1\nVADDPS %ZMM22,%ZMM28,%ZMM0          | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVCVTPS2PD %YMM0,%ZMM6               | 2     | 0.50 | 0    | 0    | 0    | 0  | 1.50 | 0    | 0  | 7       | 1\nVEXTRACTF32X8 $0x1,%ZMM0,%YMM5      | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVMOVAPS %ZMM28,%ZMM0                | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 0       | 0.25\nVSQRTPD %ZMM6,%ZMM29                | 3     | 2    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 24-33   | 18-24\nVCVTPS2PD %YMM5,%ZMM5               | 2     | 0.50 | 0    | 0    | 0    | 0  | 1.50 | 0    | 0  | 7       | 1\nVMULPD %ZMM29,%ZMM6,%ZMM6           | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVFMADD132PS %ZMM21,%ZMM20,%ZMM0     | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVSQRTPD %ZMM5,%ZMM31                | 3     | 2    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 24-33   | 18-24\nVMULPD %ZMM31,%ZMM5,%ZMM5           | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVMOVUPS (%R8,%R11,1),%ZMM13{%K1}    | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nADD $0x40,%R11                      | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0  | 1       | 0.25\nVMOVAPS %ZMM13,%ZMM27{%K1}{z}       | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 0       | 0.25\nVFMADD132PS %ZMM28,%ZMM19,%ZMM0     | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVDIVPD %ZMM6,%ZMM14,%ZMM6           | 3     | 2.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 24      | 16\nVDIVPD %ZMM5,%ZMM14,%ZMM5           | 3     | 2.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 24      | 16\nVFMADD132PS %ZMM28,%ZMM18,%ZMM0     | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVFMADD132PS %ZMM28,%ZMM17,%ZMM0     | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVFMADD132PS %ZMM28,%ZMM16,%ZMM0     | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVCVTPS2PD %YMM0,%ZMM28              | 2     | 0.50 | 0    | 0    | 0    | 0  | 1.50 | 0    | 0  | 7       | 1\nVEXTRACTF32X8 $0x1,%ZMM0,%YMM0      | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVADDPD %ZMM28,%ZMM6,%ZMM6           | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVCVTPS2PD %YMM0,%ZMM0               | 2     | 0.50 | 0    | 0    | 0    | 0  | 1.50 | 0    | 0  | 7       | 1\nVADDPD %ZMM0,%ZMM5,%ZMM5            | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVCVTPD2PS %ZMM6,%YMM6               | 2     | 0.50 | 0    | 0    | 0    | 0  | 1.50 | 0    | 0  | 7       | 1\nVCVTPD2PS %ZMM5,%YMM0               | 2     | 0.50 | 0    | 0    | 0    | 0  | 1.50 | 0    | 0  | 7       | 1\nVINSERTF64X4 $0x1,%YMM0,%ZMM6,%ZMM5 | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVMULPS %ZMM27,%ZMM5,%ZMM6           | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVMULPS %ZMM6,%ZMM9,%ZMM0{%K2}{z}    | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVMULPS %ZMM6,%ZMM8,%ZMM9{%K2}{z}    | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVMULPS %ZMM6,%ZMM30,%ZMM8{%K2}{z}   | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVADDPS %ZMM0,%ZMM10,%ZMM10          | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVADDPS %ZMM9,%ZMM11,%ZMM11          | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nVADDPS %ZMM8,%ZMM12,%ZMM12          | 1     | 0.50 | 0    | 0    | 0    | 0  | 0.50 | 0    | 0  | 4       | 0.50\nCMP %R11,%RBX                       | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0  | 1       | 0.25\nJNE 401a90 <Step10_orig+0xb0>       | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0  | 0       | 0.50-1\n",
        },
      },
      header = {
        "9% of peak computational performance is used (6.00 out of 64.00 FLOP per cycle (GFLOPS @ 1GHz))",
      },
      brief = {
      },
      gain = {
        {
          details = "All SSE/AVX instructions are used in vector version (process two or more data elements in vector registers).\n",
          title = "Vectorization",
          txt = "Your loop is vectorized, but using 92% register length (average across all SSE/AVX instructions).\n",
        },
        {
          workaround = " - Reduce the number of division or square root instructions:\n  * If denominator is constant over iterations, use reciprocal (replace x/y with x*(1/y)). Check precision impact. This will be done by your compiler with ffast-math or Ofast\n - If you accept to loose numerical precision up to 2 ulp, you can speedup your code by passing the following options to your compiler: (ffast-math or Ofast) and mrecip\n",
          title = "Execution units bottlenecks",
          txt = "Performance is limited by execution of divide and square root operations (the divide/square root unit is a bottleneck).\n\nBy removing all these bottlenecks, you can lower the cost of an iteration from 80.00 to 26.00 cycles (3.08x speedup).\n",
        },
      },
      potential = {
        {
          title = "Expensive FP math instructions/calls",
          txt = "Detected performance impact from expensive FP math instructions/calls.\nBy removing/reexpressing them, you can lower the cost of an iteration from 80.00 to 20.00 cycles (4.00x speedup).",
        },
        {
          workaround = "If your loop is irregular, try to remove or hoist conditional structures out of your loop. If it mixes elements of different sizes, try to uniformize them.",
          details = "Vector registers are partially exploited, which is expected if your loop is irregular or mixes elements of different sizes.",
          title = "Masked instructions",
          txt = "Detected masked instructions.",
        },
        {
          workaround = "Try to change order in which elements are evaluated (using parentheses) in arithmetic expressions containing both ADD/SUB and MUL operations to enable your compiler to generate FMA instructions wherever possible.\nFor instance a + b*c is a valid FMA (MUL then ADD).\nHowever (a+b)* c cannot be translated into an FMA (ADD then MUL).",
          title = "FMA",
          txt = "Detected 112 FMA (fused multiply-add) operations.\nPresence of both ADD/SUB and MUL operations.",
        },
      },
    },
  common = {
    header = {
      "The loop is defined in /home/kcamus/qaas_runs/169-401-3406/intel/HACCmk/build/HACCmk/src/Step10_orig.c:19-31.\n",
      "The related source loop is not unrolled or unrolled with no peel/tail loop.",
    },
    nb_paths = 1,
  },
}
