_cqa_text_report = {
  paths = {
    {
      hint = {
        {
          details = "These instructions generate more than one micro-operation and only one of them can be decoded during a cycle and the extra micro-operations increase pressure on execution units.\n - VCVTPD2PS: 2 occurrences\n - VCVTPS2PD: 4 occurrences\n - VMASKMOVPS: 1 occurrences\n",
          title = "Complex instructions",
          txt = "Detected COMPLEX INSTRUCTIONS.\n",
        },
        {
          workaround = " - Pass to your compiler a micro-architecture specialization option:\n  * Please read your compiler manual\n - Use vector aligned instructions:\n  1) align your arrays on 64 bytes boundaries: replace { void *p = malloc (size); } with { void *p; posix_memalign (&p, 64, size); }.\n  2) inform your compiler that your arrays are vector aligned: read your compiler manual.\n",
          details = " - VEXTRACTF128: 2 occurrences\n - VINSERTF128: 1 occurrences\n",
          title = "Vector unaligned load/store instructions",
          txt = "Detected 3 suboptimal vector unaligned load/store instructions.\n",
        },
        {
          workaround = "Avoid mixing data with different types. In particular, check if the type of constants is the same as array elements. Use double instead of single precision only when/where needed by numerical stability and avoid mixing precision. In C/C++, FP constants are double precision by default and must be suffixed by 'f' to make them single precision.",
          details = " - VCVTPD2PS (FP64 to FP32, SIMD): 2 occurrences\n - VCVTPS2PD (FP32 to FP64, SIMD): 4 occurrences\n",
          title = "Conversion instructions",
          txt = "Detected expensive conversion instructions.",
        },
        {
          title = "Type of elements and instruction set",
          txt = "18 AVX instructions are processing arithmetic or math operations on single precision FP elements in vector mode (eight at a time).\n8 AVX instructions are processing arithmetic or math operations on double precision FP elements in vector mode (four at a time).\n",
        },
        {
          title = "Matching between your loop (in the source code) and the binary loop",
          txt = "The binary loop is composed of 248 FP arithmetical operations:\n - 120: addition or subtraction (88 inside FMA instructions)\n - 112: multiply (88 inside FMA instructions)\n - 8: divide\n - 8: square root\nThe binary loop is loading 216 bytes (54 single precision FP elements).",
        },
        {
          title = "Arithmetic intensity",
          txt = "Arithmetic intensity is 1.15 FP operations per loaded or stored byte.",
        },
      },
      expert = {
        {
          title = "General properties",
          txt = "nb instructions    : 50\nnb uops            : 56\nloop length        : 264\nused x86 registers : 7\nused mmx registers : 0\nused xmm registers : 4\nused ymm registers : 16\nused zmm registers : 0\nnb stack references: 2\nADD-SUB / MUL ratio: 1.00\n",
        },
        {
          title = "Front-end",
          txt = "ASSUMED MACRO FUSION\nFIT IN UOP CACHE\nmicro-operation queue: 14.00 cycles\nfront end            : 14.00 cycles\n",
        },
        {
          title = "Back-end",
          txt = "       | P0    | P1    | P2   | P3   | P4   | P5    | P6   | P7\n-----------------------------------------------------------------\nuops   | 16.00 | 16.00 | 6.00 | 6.00 | 0.00 | 11.00 | 2.00 | 0.00\ncycles | 16.00 | 16.00 | 6.00 | 6.00 | 0.00 | 11.00 | 2.00 | 0.00\n\nCycles executing div or sqrt instructions: 34.00-40.00\nLongest recurrence chain latency (RecMII): 4.00\n",
        },
        {
          title = "Front-end and detailed OoO resources (UFS)",
          txt = "FE+BE cycles           : 34.83-42.29\nStall cycles           : 20.38-27.84\nRS full (events)       : 0.11\nPRF_FLOAT full (events): 23.36-31.80\n",
        },
        {
          title = "Cycles summary",
          txt = "Front-end : 14.00\nDispatch  : 16.00\nDIV/SQRT  : 34.00-40.00\nData deps.: 4.00\nOverall L1: 34.00-40.00\n",
        },
        {
          title = "Vectorization ratios",
          txt = "all     : 87%\nload    : 50%\nstore   : NA (no store vectorizable/vectorized instructions)\nmul     : 100%\nadd-sub : 100%\nfma     : 100%\ndiv/sqrt: 100%\nother   : 68%\n",
        },
        {
          title = "Vector efficiency ratios",
          txt = "all     : 40%\nload    : 28%\nstore   : NA (no store vectorizable/vectorized instructions)\nmul     : 50%\nadd-sub : 50%\nfma     : 50%\ndiv/sqrt: 50%\nother   : 25%\n",
        },
        {
          title = "Cycles and memory resources usage",
          txt = "Assuming all data fit into the L1 cache, each iteration of the binary loop takes 40.00 cycles. At this rate:\n - 4% of peak load performance is reached (5.40 out of 128.00 bytes loaded per cycle (GB/s @ 1GHz))\n",
        },
        {
          title = "Front-end bottlenecks",
          txt = "Found no such bottlenecks.",
        },
        {
          title = "ASM code",
          txt = "In the binary file, the address of the loop is: 401c20\n\nInstruction                         | Nb FU | P0   | P1   | P2   | P3   | P4 | P5   | P6   | P7 | Latency | Recip. throughput\n-----------------------------------------------------------------------------------------------------------------------------\nVMOVUPS (%RSI,%RBX,4),%YMM0         | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nVSUBPS 0x40(%RSP),%YMM0,%YMM0       | 1     | 0.50 | 0.50 | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 4       | 0.50\nVMOVUPS (%RDX,%RBX,4),%YMM11        | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nVSUBPS 0x20(%RSP),%YMM11,%YMM15     | 1     | 0.50 | 0.50 | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 4       | 0.50\nVMOVUPS (%RCX,%RBX,4),%YMM14        | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nVMULPS %YMM0,%YMM0,%YMM11           | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231PS %YMM15,%YMM15,%YMM11    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVSUBPS %YMM8,%YMM14,%YMM14          | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231PS %YMM14,%YMM14,%YMM11    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVADDPS %YMM10,%YMM11,%YMM3          | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTPS2PD %XMM3,%YMM2               | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVSQRTPD %YMM2,%YMM1                 | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-19   | 9-12\nVBROADCASTSS 0x75e4(%RIP),%YMM5     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5       | 0.50\nVBROADCASTSS 0x75df(%RIP),%YMM7     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5       | 0.50\nVFMADD213PS %YMM7,%YMM11,%YMM5      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVBROADCASTSS 0x75d5(%RIP),%YMM7     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5       | 0.50\nVFMADD213PS %YMM7,%YMM11,%YMM5      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVMULPD %YMM2,%YMM2,%YMM2            | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVBROADCASTSS 0x75c7(%RIP),%YMM7     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5       | 0.50\nVFMADD213PS %YMM7,%YMM11,%YMM5      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVDIVPD %YMM2,%YMM13,%YMM2           | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-14   | 8\nVBROADCASTSS 0x75b9(%RIP),%YMM7     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5       | 0.50\nVFMADD213PS %YMM7,%YMM11,%YMM5      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVBROADCASTSS 0x75af(%RIP),%YMM7     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5       | 0.50\nVFMADD213PS %YMM7,%YMM11,%YMM5      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTPS2PD %XMM5,%YMM7               | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVFMADD231PD %YMM2,%YMM1,%YMM7       | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVEXTRACTF128 $0x1,%YMM3,%XMM1       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVCVTPS2PD %XMM1,%YMM1               | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVMULPD %YMM1,%YMM1,%YMM2            | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVSQRTPD %YMM1,%YMM1                 | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-19   | 9-12\nVDIVPD %YMM2,%YMM13,%YMM2           | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-14   | 8\nVEXTRACTF128 $0x1,%YMM5,%XMM3       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVCVTPS2PD %XMM3,%YMM3               | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVCVTPD2PS %YMM7,%XMM5               | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVFMADD231PD %YMM2,%YMM1,%YMM3       | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTPD2PS %YMM3,%XMM1               | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVINSERTF128 $0x1,%XMM1,%YMM5,%YMM1  | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVCMPPS $0x1,%YMM9,%YMM11,%YMM2      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVMASKMOVPS (%R8,%RBX,4),%YMM2,%YMM2 | 2     | 0.33 | 0.33 | 0.50 | 0.50 | 0  | 0.33 | 0    | 0  | 3       | 0.50\nVMULPS %YMM1,%YMM2,%YMM1            | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVXORPS %XMM2,%XMM2,%XMM2            | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 0       | 0.25\nVCMPPS $0x1,%YMM11,%YMM2,%YMM2      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVANDPS %YMM1,%YMM2,%YMM1            | 1     | 0.33 | 0.33 | 0    | 0    | 0  | 0.33 | 0    | 0  | 1       | 0.33\nVFMADD231PS %YMM0,%YMM1,%YMM4       | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231PS %YMM15,%YMM1,%YMM12     | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231PS %YMM14,%YMM1,%YMM6      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nADD $0x8,%RBX                       | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0  | 1       | 0.25\nCMP %RDI,%RBX                       | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0  | 1       | 0.25\nJB 401c20 <Step10_orig+0x90>        | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0  | 0       | 0.50-1\n",
        },
      },
      header = {
        "9% of peak computational performance is used (6.20 out of 64.00 FLOP per cycle (GFLOPS @ 1GHz))",
      },
      brief = {
      },
      gain = {
        {
          details = "87% of SSE/AVX instructions are used in vector version (process two or more data elements in vector registers):\n - 50% of SSE/AVX loads are used in vector version.\n - 68% of SSE/AVX instructions that are not load, store, addition, subtraction nor multiply instructions are used in vector version.\n",
          title = "Vectorization",
          txt = "Your loop is partially vectorized.\nOnly 40% of vector register length is used (average across all SSE/AVX instructions).\n",
        },
        {
          workaround = "Reduce the number of division or square root instructions:\n - If denominator is constant over iterations, use reciprocal (replace x/y with x*(1/y)). Check precision impact.\n",
          title = "Execution units bottlenecks",
          txt = "Performance is limited by execution of divide and square root operations (the divide/square root unit is a bottleneck).\n\nBy removing all these bottlenecks, you can lower the cost of an iteration from 40.00 to 16.00 cycles (2.50x speedup).\n",
        },
      },
      potential = {
        {
          title = "512-bits vectorization on Skylake SP and Icelake Server",
          txt = "On Gold 5122, 6xxx and Platinum Skylake processors and Icelake Server processors, performance can be improved by using 512-bits vectorization if the number of vectorized loops is high and with high trip count.\n",
        },
        {
          title = "Expensive FP math instructions/calls",
          txt = "Detected performance impact from expensive FP math instructions/calls.\nBy removing/reexpressing them, you can lower the cost of an iteration from 40.00 to 16.00 cycles (2.50x speedup).",
        },
        {
          workaround = "Try to change order in which elements are evaluated (using parentheses) in arithmetic expressions containing both ADD/SUB and MUL operations to enable your compiler to generate FMA instructions wherever possible.\nFor instance a + b*c is a valid FMA (MUL then ADD).\nHowever (a+b)* c cannot be translated into an FMA (ADD then MUL).",
          title = "FMA",
          txt = "Detected 88 FMA (fused multiply-add) operations.\nPresence of both ADD/SUB and MUL operations.",
        },
      },
    },
  },
  AVG = {
      hint = {
        {
          details = "These instructions generate more than one micro-operation and only one of them can be decoded during a cycle and the extra micro-operations increase pressure on execution units.\n - VCVTPD2PS: 2 occurrences\n - VCVTPS2PD: 4 occurrences\n - VMASKMOVPS: 1 occurrences\n",
          title = "Complex instructions",
          txt = "Detected COMPLEX INSTRUCTIONS.\n",
        },
        {
          workaround = " - Pass to your compiler a micro-architecture specialization option:\n  * Please read your compiler manual\n - Use vector aligned instructions:\n  1) align your arrays on 64 bytes boundaries: replace { void *p = malloc (size); } with { void *p; posix_memalign (&p, 64, size); }.\n  2) inform your compiler that your arrays are vector aligned: read your compiler manual.\n",
          details = " - VEXTRACTF128: 2 occurrences\n - VINSERTF128: 1 occurrences\n",
          title = "Vector unaligned load/store instructions",
          txt = "Detected 3 suboptimal vector unaligned load/store instructions.\n",
        },
        {
          workaround = "Avoid mixing data with different types. In particular, check if the type of constants is the same as array elements. Use double instead of single precision only when/where needed by numerical stability and avoid mixing precision. In C/C++, FP constants are double precision by default and must be suffixed by 'f' to make them single precision.",
          details = " - VCVTPD2PS (FP64 to FP32, SIMD): 2 occurrences\n - VCVTPS2PD (FP32 to FP64, SIMD): 4 occurrences\n",
          title = "Conversion instructions",
          txt = "Detected expensive conversion instructions.",
        },
        {
          title = "Type of elements and instruction set",
          txt = "18 AVX instructions are processing arithmetic or math operations on single precision FP elements in vector mode (eight at a time).\n8 AVX instructions are processing arithmetic or math operations on double precision FP elements in vector mode (four at a time).\n",
        },
        {
          title = "Matching between your loop (in the source code) and the binary loop",
          txt = "The binary loop is composed of 248 FP arithmetical operations:\n - 120: addition or subtraction (88 inside FMA instructions)\n - 112: multiply (88 inside FMA instructions)\n - 8: divide\n - 8: square root\nThe binary loop is loading 216 bytes (54 single precision FP elements).",
        },
        {
          title = "Arithmetic intensity",
          txt = "Arithmetic intensity is 1.15 FP operations per loaded or stored byte.",
        },
      },
      expert = {
        {
          title = "General properties",
          txt = "nb instructions    : 50\nnb uops            : 56\nloop length        : 264\nused x86 registers : 7\nused mmx registers : 0\nused xmm registers : 4\nused ymm registers : 16\nused zmm registers : 0\nnb stack references: 2\nADD-SUB / MUL ratio: 1.00\n",
        },
        {
          title = "Front-end",
          txt = "ASSUMED MACRO FUSION\nFIT IN UOP CACHE\nmicro-operation queue: 14.00 cycles\nfront end            : 14.00 cycles\n",
        },
        {
          title = "Back-end",
          txt = "       | P0    | P1    | P2   | P3   | P4   | P5    | P6   | P7\n-----------------------------------------------------------------\nuops   | 16.00 | 16.00 | 6.00 | 6.00 | 0.00 | 11.00 | 2.00 | 0.00\ncycles | 16.00 | 16.00 | 6.00 | 6.00 | 0.00 | 11.00 | 2.00 | 0.00\n\nCycles executing div or sqrt instructions: 34.00-40.00\nLongest recurrence chain latency (RecMII): 4.00\n",
        },
        {
          title = "Front-end and detailed OoO resources (UFS)",
          txt = "FE+BE cycles           : 34.83-42.29\nStall cycles           : 20.38-27.84\nRS full (events)       : 0.11\nPRF_FLOAT full (events): 23.36-31.80\n",
        },
        {
          title = "Cycles summary",
          txt = "Front-end : 14.00\nDispatch  : 16.00\nDIV/SQRT  : 34.00-40.00\nData deps.: 4.00\nOverall L1: 34.00-40.00\n",
        },
        {
          title = "Vectorization ratios",
          txt = "all     : 87%\nload    : 50%\nstore   : NA (no store vectorizable/vectorized instructions)\nmul     : 100%\nadd-sub : 100%\nfma     : 100%\ndiv/sqrt: 100%\nother   : 68%\n",
        },
        {
          title = "Vector efficiency ratios",
          txt = "all     : 40%\nload    : 28%\nstore   : NA (no store vectorizable/vectorized instructions)\nmul     : 50%\nadd-sub : 50%\nfma     : 50%\ndiv/sqrt: 50%\nother   : 25%\n",
        },
        {
          title = "Cycles and memory resources usage",
          txt = "Assuming all data fit into the L1 cache, each iteration of the binary loop takes 40.00 cycles. At this rate:\n - 4% of peak load performance is reached (5.40 out of 128.00 bytes loaded per cycle (GB/s @ 1GHz))\n",
        },
        {
          title = "Front-end bottlenecks",
          txt = "Found no such bottlenecks.",
        },
        {
          title = "ASM code",
          txt = "In the binary file, the address of the loop is: 401c20\n\nInstruction                         | Nb FU | P0   | P1   | P2   | P3   | P4 | P5   | P6   | P7 | Latency | Recip. throughput\n-----------------------------------------------------------------------------------------------------------------------------\nVMOVUPS (%RSI,%RBX,4),%YMM0         | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nVSUBPS 0x40(%RSP),%YMM0,%YMM0       | 1     | 0.50 | 0.50 | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 4       | 0.50\nVMOVUPS (%RDX,%RBX,4),%YMM11        | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nVSUBPS 0x20(%RSP),%YMM11,%YMM15     | 1     | 0.50 | 0.50 | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 4       | 0.50\nVMOVUPS (%RCX,%RBX,4),%YMM14        | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5-6     | 0.50\nVMULPS %YMM0,%YMM0,%YMM11           | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231PS %YMM15,%YMM15,%YMM11    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVSUBPS %YMM8,%YMM14,%YMM14          | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231PS %YMM14,%YMM14,%YMM11    | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVADDPS %YMM10,%YMM11,%YMM3          | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTPS2PD %XMM3,%YMM2               | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVSQRTPD %YMM2,%YMM1                 | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-19   | 9-12\nVBROADCASTSS 0x75e4(%RIP),%YMM5     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5       | 0.50\nVBROADCASTSS 0x75df(%RIP),%YMM7     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5       | 0.50\nVFMADD213PS %YMM7,%YMM11,%YMM5      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVBROADCASTSS 0x75d5(%RIP),%YMM7     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5       | 0.50\nVFMADD213PS %YMM7,%YMM11,%YMM5      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVMULPD %YMM2,%YMM2,%YMM2            | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVBROADCASTSS 0x75c7(%RIP),%YMM7     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5       | 0.50\nVFMADD213PS %YMM7,%YMM11,%YMM5      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVDIVPD %YMM2,%YMM13,%YMM2           | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-14   | 8\nVBROADCASTSS 0x75b9(%RIP),%YMM7     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5       | 0.50\nVFMADD213PS %YMM7,%YMM11,%YMM5      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVBROADCASTSS 0x75af(%RIP),%YMM7     | 1     | 0    | 0    | 0.50 | 0.50 | 0  | 0    | 0    | 0  | 5       | 0.50\nVFMADD213PS %YMM7,%YMM11,%YMM5      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTPS2PD %XMM5,%YMM7               | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVFMADD231PD %YMM2,%YMM1,%YMM7       | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVEXTRACTF128 $0x1,%YMM3,%XMM1       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVCVTPS2PD %XMM1,%YMM1               | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVMULPD %YMM1,%YMM1,%YMM2            | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVSQRTPD %YMM1,%YMM1                 | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-19   | 9-12\nVDIVPD %YMM2,%YMM13,%YMM2           | 1     | 1    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 13-14   | 8\nVEXTRACTF128 $0x1,%YMM5,%XMM3       | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVCVTPS2PD %XMM3,%YMM3               | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVCVTPD2PS %YMM7,%XMM5               | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVFMADD231PD %YMM2,%YMM1,%YMM3       | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVCVTPD2PS %YMM3,%XMM1               | 2     | 0.50 | 0.50 | 0    | 0    | 0  | 1    | 0    | 0  | 7       | 1\nVINSERTF128 $0x1,%XMM1,%YMM5,%YMM1  | 1     | 0    | 0    | 0    | 0    | 0  | 1    | 0    | 0  | 3       | 1\nVCMPPS $0x1,%YMM9,%YMM11,%YMM2      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVMASKMOVPS (%R8,%RBX,4),%YMM2,%YMM2 | 2     | 0.33 | 0.33 | 0.50 | 0.50 | 0  | 0.33 | 0    | 0  | 3       | 0.50\nVMULPS %YMM1,%YMM2,%YMM1            | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVXORPS %XMM2,%XMM2,%XMM2            | 1     | 0    | 0    | 0    | 0    | 0  | 0    | 0    | 0  | 0       | 0.25\nVCMPPS $0x1,%YMM11,%YMM2,%YMM2      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVANDPS %YMM1,%YMM2,%YMM1            | 1     | 0.33 | 0.33 | 0    | 0    | 0  | 0.33 | 0    | 0  | 1       | 0.33\nVFMADD231PS %YMM0,%YMM1,%YMM4       | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231PS %YMM15,%YMM1,%YMM12     | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nVFMADD231PS %YMM14,%YMM1,%YMM6      | 1     | 0.50 | 0.50 | 0    | 0    | 0  | 0    | 0    | 0  | 4       | 0.50\nADD $0x8,%RBX                       | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0  | 1       | 0.25\nCMP %RDI,%RBX                       | 1     | 0.25 | 0.25 | 0    | 0    | 0  | 0.25 | 0.25 | 0  | 1       | 0.25\nJB 401c20 <Step10_orig+0x90>        | 1     | 0.50 | 0    | 0    | 0    | 0  | 0    | 0.50 | 0  | 0       | 0.50-1\n",
        },
      },
      header = {
        "9% of peak computational performance is used (6.20 out of 64.00 FLOP per cycle (GFLOPS @ 1GHz))",
      },
      brief = {
      },
      gain = {
        {
          details = "87% of SSE/AVX instructions are used in vector version (process two or more data elements in vector registers):\n - 50% of SSE/AVX loads are used in vector version.\n - 68% of SSE/AVX instructions that are not load, store, addition, subtraction nor multiply instructions are used in vector version.\n",
          title = "Vectorization",
          txt = "Your loop is partially vectorized.\nOnly 40% of vector register length is used (average across all SSE/AVX instructions).\n",
        },
        {
          workaround = "Reduce the number of division or square root instructions:\n - If denominator is constant over iterations, use reciprocal (replace x/y with x*(1/y)). Check precision impact.\n",
          title = "Execution units bottlenecks",
          txt = "Performance is limited by execution of divide and square root operations (the divide/square root unit is a bottleneck).\n\nBy removing all these bottlenecks, you can lower the cost of an iteration from 40.00 to 16.00 cycles (2.50x speedup).\n",
        },
      },
      potential = {
        {
          title = "512-bits vectorization on Skylake SP and Icelake Server",
          txt = "On Gold 5122, 6xxx and Platinum Skylake processors and Icelake Server processors, performance can be improved by using 512-bits vectorization if the number of vectorized loops is high and with high trip count.\n",
        },
        {
          title = "Expensive FP math instructions/calls",
          txt = "Detected performance impact from expensive FP math instructions/calls.\nBy removing/reexpressing them, you can lower the cost of an iteration from 40.00 to 16.00 cycles (2.50x speedup).",
        },
        {
          workaround = "Try to change order in which elements are evaluated (using parentheses) in arithmetic expressions containing both ADD/SUB and MUL operations to enable your compiler to generate FMA instructions wherever possible.\nFor instance a + b*c is a valid FMA (MUL then ADD).\nHowever (a+b)* c cannot be translated into an FMA (ADD then MUL).",
          title = "FMA",
          txt = "Detected 88 FMA (fused multiply-add) operations.\nPresence of both ADD/SUB and MUL operations.",
        },
      },
    },
  common = {
    header = {
      "The loop is defined in /home/kcamus/qaas_runs/169-401-3406/intel/HACCmk/build/HACCmk/src/Step10_orig.c:19-35.\n",
      "The related source loop is not unrolled or unrolled with no peel/tail loop.",
    },
    nb_paths = 1,
  },
}
